/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_support.S 2148 2011-07-11 00:03:15Z ertl-honda $
 */

/*
 *  ץå¸⥸塼 ֥SH34ѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

/*
 *  ֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"

#include "target_mmu.h"
    
#ifdef FPU_ENABLE

/*
 *  FPUϢ쥸¸
 */        
#ifdef FPU_SAVE_BANKED_REG

#define OFFSET_OF_SSR (11 + 14 + 16)

.macro save_banked_fpureg
    frchg  /* Х󥯤ڤؤ */
    fmov.s  fr15, @-r15
    fmov.s  fr14, @-r15
    fmov.s  fr13, @-r15
    fmov.s  fr12, @-r15
    fmov.s  fr11, @-r15
    fmov.s  fr10, @-r15
    fmov.s  fr9, @-r15
    fmov.s  fr8, @-r15
    fmov.s  fr7, @-r15
    fmov.s  fr6, @-r15
    fmov.s  fr5, @-r15
    fmov.s  fr4, @-r15
    fmov.s  fr3, @-r15
    fmov.s  fr2, @-r15
    fmov.s  fr1, @-r15
    fmov.s  fr0, @-r15
    frchg  /* Х󥯤᤹ */
.endm

.macro restore_banked_fpureg
#ifdef FPU_SAVE_BANKED_REG
    frchg  /* Х󥯤ڤؤ */
    fmov.s  @r15+, fr0
    fmov.s  @r15+, fr1
    fmov.s  @r15+, fr2
    fmov.s  @r15+, fr3
    fmov.s  @r15+, fr4
    fmov.s  @r15+, fr5
    fmov.s  @r15+, fr6
    fmov.s  @r15+, fr7
    fmov.s  @r15+, fr8
    fmov.s  @r15+, fr9
    fmov.s  @r15+, fr10
    fmov.s  @r15+, fr11
    fmov.s  @r15+, fr12
    fmov.s  @r15+, fr13
    fmov.s  @r15+, fr14
    fmov.s  @r15+, fr15
    frchg  /* Х󥯤᤹ */
#endif /* FPU_SAVE_BANKED_REG */
.endm

#else /* FPU_SAVE_BANKED_REG */

#define OFFSET_OF_SSR (11 + 14)

.macro save_banked_fpureg
.endm

.macro restore_banked_fpureg
.endm

#endif /* FPU_SAVE_BANKED_REG */

.macro save_scratch_fpureg label
    save_banked_fpureg
    sts.l   fpul, @-r15
    fmov.s  fr11, @-r15
    fmov.s  fr10, @-r15
    fmov.s  fr9,  @-r15
    fmov.s  fr8,  @-r15
    fmov.s  fr7,  @-r15
    fmov.s  fr6,  @-r15
    fmov.s  fr5,  @-r15
    fmov.s  fr4,  @-r15
    fmov.s  fr3,  @-r15
    fmov.s  fr2,  @-r15
    fmov.s  fr1,  @-r15
    fmov.s  fr0,  @-r15
    sts.l   fpscr, @-r15
    mov.l   _fpscr_init_\label, r0 /* fpscr νͤ */
    lds     r0,   fpscr
.endm

.macro restore_scratch_fpureg 
    lds.l   @r15+, fpscr
    fmov.s  @r15+, fr0
    fmov.s  @r15+, fr1
    fmov.s  @r15+, fr2
    fmov.s  @r15+, fr3
    fmov.s  @r15+, fr4
    fmov.s  @r15+, fr5
    fmov.s  @r15+, fr6
    fmov.s  @r15+, fr7
    fmov.s  @r15+, fr8
    fmov.s  @r15+, fr9
    fmov.s  @r15+, fr10
    fmov.s  @r15+, fr11
    lds.l   @r15+, fpul
    restore_banked_fpureg
.endm

.macro save_fpureg_data label
_fpscr_init_\label:
    .long     (FPSCR_PR_INIT|FPSCR_INIT)
.endm

.macro save_callsaved_fpureg_dis
    save_banked_fpureg
    fmov.s  fr15, @-r15
    fmov.s  fr14, @-r15
    fmov.s  fr13, @-r15
    fmov.s  fr12, @-r15
    sts.l   fpscr, @-r15
.endm

.macro restore_callsaved_fpureg_dis
    lds.l   @r15+, fpscr
    fmov.s  @r15+, fr12
    fmov.s  @r15+, fr13
    fmov.s  @r15+, fr14
    fmov.s  @r15+, fr15
    restore_banked_fpureg
.endm

.macro save_callsaved_fpureg_int
    lds.l   @r15+, fpscr   /* åfpscr */
    sts.l   fpscr, @-r15   /* åѤ¸    */
    fmov.s  fr15, @-r15
    fmov.s  fr14, @-r15
    fmov.s  fr13, @-r15
    fmov.s  fr12, @-r15
    sts.l   fpscr, @-r15
.endm

.macro restore_callsaved_fpureg_int
    lds.l   @r15+, fpscr
    fmov.s  @r15+, fr12
    fmov.s  @r15+, fr13
    fmov.s  @r15+, fr14
    fmov.s  @r15+, fr15
.endm

.macro set_fpscr label
    mov.l   _fpscr_init_\label, r2
    lds     r2, fpscr
.endm

#else /* FPU_ENABLE */

#define OFFSET_OF_SSR  11

.macro save_scratch_fpureg label
.endm

.macro restore_scratch_fpureg
.endm

.macro save_fpureg_data label
.endm

.macro save_callsaved_fpureg_dis
.endm

.macro restore_callsaved_fpureg_dis
.endm

.macro save_callsaved_fpureg_int
.endm

.macro restore_callsaved_fpureg_int
.endm

.macro set_fpscr label
.endm

#endif /* FPU_ENABLE */

/*
 *  㳰/߽롼
 *  SH34ϥ٥ơ֥㳰,TRAPAȯVBR+0x100Ϥ
 *  //NMIߤȯȡVBR+0x600Ϥ¹Ԥ롣
 */

/*
 *  VBR ꤹ
 */
    .section .text
    .align 2
    .global _base_vec
_base_vec:
     nop 
     nop
     nop

/*
 *  Exception 100 vector
 *  ɥ쥹顼,å̿㳰Trapa㳰ȯȼ¹Ԥ롣
 *
 *  CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롢ΤᡢCPU㳰ϥ
 *  ɥƤӽФ㳰/ߤ򼨤쥸Х1 r7 쥸򥤥
 *  Ȥ꥿󤷤Ƥ˥ǥȤ롣CPU㳰ϥɥ齪λϡ
 *  ret_exc ˤơиԤ
 * 
 *  regflg å˳ߤػߤʤȡreqflg å˵
 *  ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥѥå
 *  ʤ
 *
 *
 *  㳰ȯȡ㳰ȯΥƥȤǤspc,pr,ssr,r0r7
 *  롣㳰ȯǤΥƥȤĴ󥿥ƥȤʤ
 *  _exception_from_int¹Ԥ򳫻Ϥ롣㳰װEXPEVT쥸ɤߡ
 *  exc_tableCPU㳰ϥɥγϤɤ߹ࡣCPU㳰ϥɥ餫
 *  ꥿󤷤Ƥ顢reqflgĴ0ʳʤrec_exc()ӡ0ʤ鸵
 *  ˥꥿󤹤롣
 *
 *
 *  BLӥåȤΰˤĤ
 *  ssr,spc ΥƥȤᤷ rte ȯԤݤˤϡߡNMI 
 *  ޤˤդʤ褦 BL ӥåȤ1ˤɬפ롥㳰/ߥ
 *  ɥ齪λˤ BL ӥåȤ1ˤ öIPM  MAX_IPM ꤹ롥
 *  ϡBL ӥåȤ1ξ㳰ȯ CPU ꥻåȤ뤳Ȥ
 *  θơΤᡤssr,spcľBL1ꤷƤ롥
 *       
 *          ----------------------
 *  0      |       EXPEVT         |  <-- p_excinf
 *          ----------------------
 *  1      |         R7           |
 *          ----------------------
 *  2      |         R6           |
 *          ----------------------
 *  3      |         R5           |
 *          ----------------------
 *  4      |         R4           |
 *          ----------------------
 *  5      |         R3           |
 *          ----------------------
 *  6      |         R2           |
 *         ----------------------
 *  7      |         R1           |
 *          ----------------------
 *  8      |         R0           |
 *          ----------------------
 *  9      |        MACH          |
 *          ----------------------
 * 10      |        MACL          |
 *          ----------------------
 * 11      |        GBR           |
 *          ----------------------
 * 12      |         SR           |
 *          ----------------------
 * 13      |         PR           |
 *          ----------------------
 * 14      |         PC           |
 *          ----------------------
 */


    .org   0x0100              /*  _BASE_VBR + 0x0100Ϥ   */
    .align 2
    .global _general_exc_vec
    .global _general_exc_vec_1
    .extern _svc_entry
    .extern _ret_tex
_general_exc_vec:
    /*
     *  㳰ȯư⡼ɤ桼⡼ɤʤСåݥ󥿤򥷥ƥ
     *  åڤؤ롥
     *  åؤ򤹤˥åݥ󥿤ڤؤΤϡåؤ
     *  TLB˥ɤƤ桼åΰϰϤۤƤޤ
     *  TLBߥ㳰ȯȡåؤ㳰ޥ֡BL==1
     *  Ǥ뤿ᡤꥻåȽ˥פƤޤǤ롥
     *  ǡ쥸Х󥯤1Ǥ뤳ȡġSH4 HRP2ͥϡ㳰
     *  ޥ֤ǤΤߥ쥸Х1Ȥ㳰ޥƤʤ֤Ǥϡ
     *  R7ʳΥ쥸Х1Υ쥸˲ǽǤ뤳Ȥ顤
     *  R0Ѥ뤳Ȥʤ
     *  ޤR15Ѥ뤳ȤǽǤ뤬ƥॹåؤڤؤ
     *  ʤˡR15SGR뤿ᡤǤʤȹͤ
     */
    stc     ssr, r0             /* r0 = 㳰ȯľSR */
    shll    r0                  /* SRMSB̵ */
    shll    r0                  /* SRMSBμΥӥåȤMD -> ø⡼ɡMD==1ˤʤT=1 */
    bt      _general_exc_vec_0  /* ȯø⡼ɤʤ饹å */
    mov.l   _p_runtsk_exc, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    mov.l   r15, @(TCB_usp, r0)     /* usp¸ */
    /* ǡusp¸Τϡ㳰䤹뤿 */
    mov.l   @(TCB_ssp, r0), r15   /* ssp򥻥å */
_general_exc_vec_0:
    stc.l   sgr,@-r15
_general_exc_vec_1:
    stc.l  spc,@-r15           /* spc,pr,ssr 򥹥å¸ */
    sts.l  pr,@-r15
    stc.l  ssr,@-r15
    stc.l  gbr,@-r15
    sts.l  macl,@-r15
    sts.l  mach,@-r15                                            
    stc.l  r0_bank,@-r15       /* 㳰ȯr0r7¸        */
    stc.l  r1_bank,@-r15
    stc.l  r2_bank,@-r15
    stc.l  r3_bank,@-r15
    stc.l  r4_bank,@-r15
    stc.l  r5_bank,@-r15
    stc.l  r6_bank,@-r15
    stc.l  r7_bank,@-r15
    save_scratch_fpureg exc
    mov.l  _expevt_exc,r0      /* 㳰ĤȾä쥸¸      */
    mov.l  @r0,r5              /* EXPEVT쥸                      */
    mov.l  r5,@-r15            /* å¸(̤Ͽ㳰ȯ)    */
    /*
     *  ӥؤʬ
     *  ӥϥƥȤư뤿ᡤͥȥȤϹʤ
     */
    mov.l   _excno_trapa_exc, r3 /* r3 = trapa̿㳰ֹ */
    cmp/eq  r3, r5 /* trapa̿ᤫ */
    bf      _kernel_exc_0   /* trapa̿Ǥʤ̾㳰 */

    mov.l   _tra_exc, r3    /* r3 = TRA쥸 */
    mov.l   @r3, r3         /* r3 = TRA쥸 */
    shlr2   r3              /* r3 = r3 >> 2 */
    mov     #NO_SVC, r0         /* r0 = NO_SVC */
    cmp/eq  r0, r3           /* r3 == NO_SVC */
    bt      _svc_entry_vec  /* svc_entry */
    nop
    mov     #NO_RET_TEX, r0     /* r0 = NO_RET_TEX */
    cmp/eq  r0, r3           /* r3 == NO_RET_TEX */
    bf      _kernel_exc_0   /* ̾CPU㳰 */
    nop
    /*
     *  ret_tex
     */
    mov.l   _ret_tex_exc, r3
    jsr     @r3                 /* ret_tex */
    nop

_ret_tex_vec_r:
    mov.l  @r15+,r2            /* EXPEVT򥹥åФ              */
    restore_scratch_fpureg
    mov.l  @r15+,r7            /* r0r1,ssr,pr,spc     */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,ssr    /* spcssrʤ */
    ldc.l   @r15+,ssr   /* sgrΤƤ */
    mov.l   _p_runtsk_exc, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _ret_tex_vec_r_1  /* ¹ǤʤХå */
    mov.l   r15, @(TCB_ssp, r0)     /* ssp */
_ret_tex_vec_r_1:
    /*
     *  ꥿CPUå㳰ޥֲ
     */
    mov.l   _mask_md_bl_noipm_exc, r0
    ldc     r0, ssr
    /*
     *  ǤSGRʤ
     *  桼ξ硤SGRˤϥ㳰꥿󤷤ȤuspäƤ뤬
     *  ret_tex꥿󤷤ǻѤ륹åϥƥॹåǤ뤿ᡥ
     *  ƥॿξ硤˥ƥॹåѤ뤿ɬפʤ
     */
    rte
    nop

    /*
     *  cal_svc
     */
_svc_entry_vec:
    mov.l   _svc_entry_exc, r3
    jsr     @r3             /* ӥ */
    nop
_svc_entry_vec_r:
    /* 
     *  λǤ㳰ޥ֤ǤBL==1쥸Х1
     *  r3_bank1˥꥿γͥ٥ޥ¸Ƥ
     */
    /*
     *  rte̿ˤ㳰ޥʤ
     *  硤ssrspcsgr줿ľ˳ߤꡤ
     *  ͤ˲Ƥޤ礬
     */
    mov.l  _unmak_rb_exc,r2 /* 쥸Х󥯤ڤؤ   */
    stc    sr,r1               
    and    r1,r2            
    ldc    r2,sr
    mov.l  @r15+,r2            /* EXPEVT򥹥åФ              */
    restore_scratch_fpureg
    mov.l  @r15+,r7            /* r0r1,ssr,pr,spc     */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    lds.l  @r15+,mach           /* r0ˤ֤ͤɬפ뤿᥹år0ϼΤƤ */
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    /*
     *  SGR򥹥åsstk or istkˤ
     *  åݥ󥿡usp, ispˤSGR
     *  褬桼⡼ɤʤSGRˤusp¸Ƥ뤿̤ưǤ롥
     *  褬ø⡼ɤʤSGRˤSGRsp¸Ƥ뤿spѲʤ
     */
    ldc.l   @r15+, r1_bank  /* r1_bank = sgr */
    ldc     r0, r0_bank /* r0΢쥸¸ */
    mov.l   _p_runtsk_exc, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _svc_entry_vec_r_1  /* ¹ǤʤХå */
    mov.l   r15, @(TCB_ssp, r0)     /* ssp */
_svc_entry_vec_r_1:
    mov.l   _unmask_ipm_exc, r0
    stc     ssr, r15
    and     r0, r15     /* ipmꥢ */
    stc     r3_bank, r0 /* ͥ٥ޥ */
    or      r15, r0
    ldc     r0, ssr     /* ꥿γͥ٥ޥ */
    stc     r0_bank, r0 /* r0 */
    stc     r1_bank, r15    /* sp */
    rte
    nop

    /*
     *  ̾㳰
     */
_kernel_exc_0:
    ldc    r15,r4_bank         /* CPU㳰ϥɥؤΰ                   */
    ldc    r5, r5_bank         /* EXPEVT쥸                        */

    /*
     * ͥCPU㳰Ƚ
     * ͥ٥ޥǤʤ֤ȯCPU㳰
     * ͥCPU㳰Ȱ
     */
    stc    sr,r0              /* SRIPM0ǤʤСͥ     */
    and    #0xf0,r0           /* CPU㳰Ȥ                              */
    tst    r0,r0
    bf     _nonkernel_exc

    /*
     * ͥCPU㳰
     */
_kernel_exc:
    tst    r7,r7               /* 㳰ȯΥƥȤȽ            */
    bf/s   _kernel_exc_1       /* ȯ㳰/ߥϥɥʤ饸 */
     add    #0x01,r7           /* 㳰/ߥͥȲ򥤥󥯥   */
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   r7, @-r15
    mov.l   _ovrtimer_stop_exc, r0
    jsr     @r0
    nop
    mov.l   @r15+, r7
#endif /* TOPPERS_SUPPORT_OVRHDR */
    mov.l  _kernel_istkpt_exc, r2
    mov    r15,r4
    mov.l  @r2,r15
    mov.l  r4,@-r15            /* åؤΥåݥ󥿤¸ */
_kernel_exc_1:
    mov.l  _lock_flag_exc,r3   /*  lock_flag 򥹥å¸           */
    mov.l  @r3, r2
    mov.l  r2,@-r15
    mov.l _saved_iipm_exc,r3   /*  saved_iipm 򥹥å¸          */
    mov.b  @r3, r2
    mov.l  r2,@-r15
    mov.l  _unmak_rb_bl_exc,r2 /* BLӥåȤ0ˡ쥸Х󥯤ڤؤ   */
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr

    mov.l r5, @-r15              /* EXPEVT򥹥å¸        */
#ifdef LOG_EXC_ENTER
    mov.l  r4,@-r15              /* r4򥹥å¸            */
    mov.l _log_exc_enter_exc, r1 /* ϴؿ                  */
    jsr   @r1
     mov  r5, r4                 /*  */
    mov.l @r15+, r4              /* r4                      */
    mov.l @r15, r5               /* 㳰װ(å줿ޤ) */
#endif /* LOG_EXC_ENTER */

    index_excno r5             /* EXPEVTexc_tableΥǥå */
    mov.l  _exch_tbl_exc,r0    /* exch_tblΥɥ쥹r0                  */
    mov.l  @(r0,r5),r2         /* ϥɥΥɥ쥹                  */
    jsr    @r2                 /* CPU㳰ϥɥ                         */
     nop

    mov.l @r15+, r4              /* EXPEVT                   */
#ifdef LOG_EXC_LEAVE
    mov.l _log_exc_leave_exc, r1 /* ϴؿ                   */
    jsr  @r1
     nop
#endif /* LOG_EXC_LEAVE */

    /*
     * CPU㳰ϥɥи
     */
_ret_exc:
    mov.l  _mask_md_ipm_exc,r0 /* ߶ػ                              */
    ldc    r0,sr               
    mov.l  @r15+,r2            /* saved_iipm 򸵤᤹                     */
    mov.l  _saved_iipm_exc,r3  
    mov.b  r2,@r3
    mov.l  @r15+,r2            /* lock_flag 򸵤᤹                      */
    mov.l  _lock_flag_exc,r3   
    mov.l  r2,@r3
    /*
     * ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     * ƤԲʬ˹Ԥɬפ롥
     * ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     * ᡤBLӥåȤ1˥åȤơͥγߤػߤ롥
     */
    mov.l  _mask_md_bl_exc,r0  /* BLӥå  1                           */
    ldc    r0,sr               /* ߶ػ                              */
    stc    r7_bank,r7          /* 㳰/ߤΥͥȲǥ   */
    dt     r7
    ldc    r7,r7_bank
    tst    r7,r7
    bf     _ret_exc_1          /* ȯʳʤ餹˥꥿      */
    mov.l  @r15, r15           /* 褬ʤΤǥå᤹        */
    mov.l  _reqflg_exc,r2      /* reqflgΥå                          */
    mov.l  @r2,r1
    xor    r0,r0
    tst    r1,r1               /* reqflgfalseʤ_ret_exc_0             */
    bt/s   _ret_exc_0          
     mov.l  r0,@r2             /* reqflg򥯥ꥢ                            */
    mov.l  _mask_md_ipm_exc,r0 /* BLӥå  0                        */
    ldc    r0, sr              /* ͥγߵ             */
    mov.l  _ret_int_2_exc, r1  /* ret_int_2                               */
    jmp    @r1
     mov.l  @r15+,r2           /* EXPEVT򥹥åФ              */

_ret_exc_0:
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   _ovrtimer_start_exc, r0
    jsr     @r0
    nop
#endif /* TOPPERS_SUPPORT_OVRHDR */
_ret_exc_1:
    mov.l  @r15+,r2            /* EXPEVT򥹥åФ              */
    restore_scratch_fpureg
    mov.l  @r15+,r7            /* r0r1,ssr,pr,spc     */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    /*
     *  SGR򥹥åsstk or istkˤ
     *  åݥ󥿡usp, ispˤSGR
     *  褬桼⡼ɤʤSGRˤusp¸Ƥ뤿̤ưǤ롥
     *  褬ø⡼ɤʤSGRˤSGRsp¸Ƥ뤿spѲʤ
     */
    ldc.l   @r15+, r1_bank  /* r1_bank = sgr */
    ldc     r0, r0_bank /* r0΢쥸¸ */
    mov.l   _p_runtsk_exc, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _ret_exc_2  /* ¹ǤʤХå */
    mov.l   r15, @(TCB_ssp, r0)     /* ssp */
_ret_exc_2:
    stc     r0_bank, r0 /* r0 */
    stc     r1_bank, r15     /* sp */
    rte
     nop

    /*
     * ͥCPU㳰
     */
_nonkernel_exc:
    tst    r7,r7               /* 㳰ȯΥƥȤȽ            */
    bf/s   _nonkernel_exc_1    /* ȯ㳰/ߥϥɥʤ饸 */
     add    #0x01,r7           /* 㳰/ߥͥȲ򥤥󥯥   */
    mov.l  _kernel_istkpt_exc, r2
    mov    r15,r4
    mov.l  @r2,r15
    mov.l  r4,@-r15            /* åؤΥåݥ󥿤¸ */
_nonkernel_exc_1:
    mov.l  _unmak_rb_bl_exc,r2 /* BLӥåȤ0ˡ쥸Х󥯤ڤؤ   */
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr
    index_excno r5             /* EXPEVTexc_tableΥǥå */
    mov.l  _exch_tbl_exc,r0    /* exch_tblΥɥ쥹r0                  */
    mov.l  @(r0,r5),r2         /* ϥɥΥɥ쥹                  */
    jsr    @r2                 /* CPU㳰ϥɥ                         */
     nop

    /*
     * ͥCPU㳰
     *
     * ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     * ƤԲʬ˹Ԥɬפ롥
     * ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     * ᡤBLӥåȤ1˥åȤơͥγߤػߤ롥
     */
    mov.l  _mask_md_bl_exc,r0  /* BLӥå  1                           */
    ldc    r0,sr               /* ߶ػ                              */
    stc    r7_bank,r7          /* 㳰/ߤΥͥȲǥ   */
    dt     r7
    ldc    r7,r7_bank
    tst    r7,r7
    bf     _ret_exc_1          /* ȯʳʤ餹˥꥿      */
    bra    _ret_exc_1          /* 褬ʤΤǥå᤹        */
     mov.l  @r15, r15          /* Υإ꥿ */

    .align  4
#ifdef TOPPERS_SUPPORT_OVRHDR
_ovrtimer_start_exc:
    .long _ovrtimer_start
_ovrtimer_stop_exc:
    .long _ovrtimer_stop
#endif /* TOPPERS_SUPPORT_OVRHDR */
_kernel_istkpt_exc:
    .long __kernel_istkpt
_expevt_exc:
    .long  EXPEVT
_unmak_rb_bl_exc:
    .long  0x4fffffff
_exch_tbl_exc:
    .long  _exch_tbl
_mask_md_ipm_exc:
    .long  (0x40000000 + INT_IPM(TMIN_INTPRI))
_reqflg_exc:
    .long  _reqflg
_mask_md_bl_exc:
    .long  (0x50000000 + INT_IPM(TMIN_INTPRI))
_lock_flag_exc:
    .long _lock_flag
_saved_iipm_exc:
    .long _saved_iipm
_ret_int_2_exc:
    .long _ret_int_2
#ifdef LOG_EXC_ENTER
_log_exc_enter_exc:
    .long _log_exc_enter
#endif /* LOG_EXC_ENTER */
#ifdef LOG_EXC_LEAVE
_log_exc_leave_exc:
    .long _log_exc_leave
#endif /* LOG_EXC_LEAVE */
save_fpureg_data exc
_unmak_rb_exc:
    .long  0x5fffffff
_excno_trapa_exc:
    .long 0x0160
_tra_exc:
    .long 0xff000020
_svc_entry_exc:
    .long __kernel_svc_entry
_ret_tex_exc:
    .long _ret_tex
_p_runtsk_exc:
    .long _p_runtsk
_mask_md_bl_noipm_exc:
    .long  0x50000000
_unmask_ipm_exc:
    .long 0xffffff0f
 
/*
 *  ư
 *
 *  ǥѥå㤫ƤӽФ뤿ᡤTCBΥɥ쥹r0
 *  äƤ
 */ 
    .text
    .align 2
    .global _start_stask_r
    .global _start_utask_r

    .section .text_kernel
    .align 2
_start_stask_r:
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   r0, @-r15
    mov.l   _ovrtimer_start_sta, r0
    jsr     @r0
    nop
    mov.l   @r15+, r0
#endif /* TOPPERS_SUPPORT_OVRHDR */
    mov.l  _lock_flag_start, r1 /* CPUå֤ */
    xor    r2,r2 
    mov.l  r2,@r1
    set_fpscr start
    mov.l  _mask_md_start,r4     /* ߵ */
    ldc    r4,sr
    mov.l  _ext_tsk_start,r2     /* Ϥ */
    lds    r2,pr 
    mov.l  @(TCB_p_tinib,r0),r3  /* p_runtsk->p_tinibr3  */
    mov.l  @(TINIB_task,r3),r1   /* ưϤr1     */
    jmp    @r1
     mov.l  @(TINIB_exinf,r3),r4 /* exinf쥸r4  */

_start_utask_r:
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   r0, @-r15
    mov.l   _ovrtimer_start_sta, r0
    jsr     @r0
    nop
    mov.l   @r15+, r0
#endif /* TOPPERS_SUPPORT_OVRHDR */
    mov.l  _lock_flag_start, r1 /* CPUå֤ˤʤ褦 */
    xor    r2,r2 
    mov.l  r2,@r1
    set_fpscr start
    mov.l   @(TCB_p_tinib, r0), r3 /* r3 = p_runtsk->p_tinib */
    mov.l   _mask_md_bl_start, r4   /* 㳰ޥ֤ */
    stc     sr, r1
    or      r4, r1
    ldc     r1, sr
    mov.l   _call_ext_tsk_start, r2 /* ϤPR */
    lds     r2, pr
    mov.l   @(TINIB_exinf,r3),r4 /* exinf쥸r4  */
    /*
     *  㳰Υ꥿ǥ桼⡼ɡߵĤȤʤꡢ
     *  εưϤ˥פ褦˽
     */
    mov     #0, r1
    mov     #TCB_priv_mode, r2
	mov.b	r1,	@(r0,r2)     /* ø⡼ɼ¹Ԥȴ */
    mov.l   @(TINIB_task,r3),r1   /* ưϤSPC     */
    ldc     r1, spc
    mov.l   @(TINIB_ustk_bottom, r3), r1 /* r1 = 桼åݥ󥿤ν */
    mov.l   _unmask_utsk_start, r2  /* r2 = 桼¹SR򥻥åȤ뤿Υޥ */
    stc     sr, r3
    and     r2, r3              /* r3 = srMDRBBLIMASK򤹤٤0 */
    ldc     r3, ssr             /* sr˥åȤ */
    mov     r1, r15            /* 桼åڤؤ */
    rte     /* 桼⡼ɡߵġεưϤ */
    nop

    .align 4
#ifdef TOPPERS_SUPPORT_OVRHDR
_ovrtimer_start_sta:
    .long _ovrtimer_start
#endif /* TOPPERS_SUPPORT_OVRHDR */
_lock_flag_start:
    .long _lock_flag
_unmask_utsk_start: /* 桼⡼ɡХ0㳰ޥIMASK=0 */   
    .long 0x00008303
_mask_md_start:    
    .long 0x40000000
_mask_md_bl_start:
    .long 0x50000000
_ext_tsk_start:
    .long _ext_tsk
_call_ext_tsk_start:
    .long _call_ext_tsk
save_fpureg_data start

    /*
     *  ext_tsktrap̿ǸƤӽФ
     */
    .global _call_ext_tsk
    .section .text_shared
    .align 2

_call_ext_tsk:
    mov     #TFN_EXT_TSK, r1
    trapa   #NO_SVC
    nop
    mov     #TFN_EXT_KER, r1
    trapa   #NO_SVC
    nop

/*
 *  ǥѥå
 *
 *  Υ롼ϡƥ(r7_bank1 = 0)CPUå֡
 *  ǥѥåľ֡ʥǥΡ˳ͥ٥ޥ֤
 *  ƤӽФ롥
 */

    .text
    .align 2
    .global _dispatch
_dispatch:
#ifdef TOPPERS_SUPPORT_OVRHDR
    sts.l   pr, @-r15
    mov.l   _ovrtimer_stop_dis, r0
    jsr     @r0
    nop
    lds.l   @r15+, pr
#endif /* TOPPERS_SUPPORT_OVRHDR */
    save_callsaved_fpureg_dis
    sts.l  pr,@-r15          /* pr,r8r14 򥹥å¸           */
    mov.l  r14,@-r15         /* r0r7ϸƤӽФ¸Ƥ뤿  */
    mov.l  r13,@-r15         /* ¸ɬפ̵                    */
    mov.l  r12,@-r15
    mov.l  r11,@-r15
    mov.l  r10,@-r15
    mov.l  r9, @-r15
    mov.l  r8, @-r15
    mov.l  _p_runtsk_dis,r2  /* r0 <- p_runtsk                      */
    mov.l  @r2,r0
    mov.l  r15,@(TCB_ssp,r0)  /* åTCB¸ 60ʲʤOK*/
    mov.l  _dispatch_r_dis,r1/* ¹ԺƳϤ¸                    */
    bra    _dispatcher
     mov.l  r1,@(TCB_pc,r0)  /* ¹ԺƳϤTCB¸  60ʲʤOK */
 
    /*
     *  TLBߥϥɥ
     */
    .section .text
    .org   0x0400              /*  _BASE_VBR + 0x0400Ϥ   */
    .align 2
    .global _tlb_miss_exc_vec
_tlb_miss_exc_vec:
    /*
     *  ڡơ֥륦
     *  r4: tlb miss address
     *  r3: upper boundr2: lower bound, r1: middle
     */
    mov.l   _tea_tlb, r4
    mov.l   @r4, r4             /* r4 = *TEA */
    mov.l   _ttb_tlb, r0    
    mov.l   @r0, r0             /* r0 = *TTB (== memtop_table) */
    mov.l   _tnum_meminib_tlb, r3
    mov.l   @r3, r3             /* r3 = tnum_meminib */
    add     #-1, r3
    mov     #0, r2              /* r2 = 0 */

search_memtop_table_0:
    cmp/eq  r2, r3              /* upper bound == lower boundʤХλ */
    bt      search_page_table
    mov     r2, r1
    add     r3, r1
    add     #1, r1
    shar    r1                  /* r1 = (r2 + r3 + 1) / 2 */
    mov     r1, r5
    shll2   r5                  
    add     r0, r5
    mov.l   @r5, r5             /* r5 = memtop_table[r1] */
    cmp/hs  r5, r4              /* r5 <= r4 ? */
    bf      search_memtop_table_1
    nop
    mov     r1, r2              /* lower bound򹹿 */
    bra     search_memtop_table_0
    nop
search_memtop_table_1:
    add     #-1, r1 
    mov     r1, r3              /* upper bound򹹿 */
    bra     search_memtop_table_0
    nop
search_page_table:
    mov.l   _p_runtsk_tlb, r1
    mov.l   @r1, r1                     /* r1 = p_runtsk */
    tst     r1, r1                      /* p_runtsk == NULL ? */
    bf      search_page_table_1
    nop
    mov.l   _page_table_info_kernel_tlb, r0  /* 󥿥ƥȤϥͥɥᥤȤߤʤ */
    bra     search_page_table_2
    nop
search_page_table_1:
    mov.l   @(TCB_p_tinib, r1), r0      /* r0 = p_tinib */
    mov.l   @(TINIB_p_dominib, r0), r0  /* r0 = p_dominib */
    mov.l   @(DOMINIB_page_table_info, r0), r0  /* r0 = page_table_info_x */
search_page_table_2:
    shll2   r2
    add     r2, r0                     
    mov.l   @r0, r0                     /* r0 = page_table_info_x[r2] */
    cmp/pz  r0                          /* r0 >= 0 ? : r0κǾ̥ӥåȤ0? */
    bt      get_ppn_and_ldtlb           /* 桼åѤν򥹥å */
    nop     /* TODO: 桼åѤν */
    cmp/eq  r0, r1                      /* p_runtsk == ڡơ֥륨ȥ ? */
    bf      conflict_tskid
    nop
    mov.l   _ustk_common_ptel_tlb, r0   /* ¹楿ΥåΰʤХ */
    bra     get_ppn_and_ldtlb
    nop
conflict_tskid:
    mov.l   _conflict_common_ptel_tlb, r0   /* ¹楿ΥåΰǤʤХػ */
get_ppn_and_ldtlb:
    mov.l   _pteh_tlb, r3
    mov.l   @r3, r3                     /* r3 = *PTEH */
    mov.l   _pte_ppn_mask, r4
    and     r4, r3                      /* r3 &= 0x1ffffc00 : ʪڡֹ */
    or      r3, r0                      /* r0ʪڡֹɲ */
    mov.l   _ptel_tlb, r3
    mov.l   r0, @r3                     /* *PTEL = r0 */
    ldtlb   /* TLB˥ڡơ֥륨ȥ */
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    rte
    nop

    .align 4
_pteh_tlb:
    .long MMU_PTEH
_ptel_tlb:
    .long MMU_PTEL
_pte_ppn_mask:
    .long 0x1ffffc00
_ttb_tlb:
    .long MMU_TTB
_tea_tlb:
    .long MMU_TEA
_tnum_meminib_tlb:
    .long __kernel_tnum_meminib
_p_runtsk_tlb:
    .long _p_runtsk
_page_table_info_kernel_tlb:
    .long _page_table_info_kernel
/*
 *  å󥰲ǽӥåȤΩƤʤư԰ˤʤ
 */
_ustk_common_ptel_tlb:
    .long 0x0000017d
_conflict_common_ptel_tlb:
    .long 0x0000011d

/*
 *  ǥѥåνи
 */
_dispatch_r:
    mov.l  @r15+,r8         /* 쥸                       */
    mov.l  @r15+,r9
    mov.l  @r15+,r10
    mov.l  @r15+,r11
    mov.l  @r15+,r12
    mov.l  @r15+,r13
    mov.l  @r15+,r14
    lds.l  @r15+,pr
    set_fpscr dis           /* fpscr ν r2˲ */
    restore_callsaved_fpureg_dis
#ifdef TOPPERS_SUPPORT_OVRHDR
    sts.l   pr, @-r15
    mov.l   r0, @-r15
    mov.l   _ovrtimer_start_dis, r0
    jsr     @r0
    nop
    mov.l   @r15+, r0
    lds.l   @r15+, pr
#endif /* TOPPERS_SUPPORT_OVRHDR */
    /*
     *  㳰롼εư
     *  dispatch_rdispatcherƤӽФ뤿ᡤ
     *  tcbΥɥ쥹r0äƤ롥
     */
    mov    r0,r1
    mov    #TCB_enatex, r0
    mov.b  @(r0,r1),r0
    mov.l  _enatex_mask_dis,r2
    tst    r0,r2
    bt/s   _dispatch_r_1        /* enatex  false ʤ꥿ */
     mov.l  @(TCB_texptn,r1),r0 /* texptn               */
    tst    r0,r0
    bt     _dispatch_r_1        /* texptn  0̵        */
    mov.l  _ipmflg_dis,r2       /* ipmflg  false ʤ꥿ */
    mov.l  @r2, r0
    tst    r0, r0
    bt     _dispatch_r_1

    mov.l   _rundom_dis, r0     /* r0 = &rundom */
    mov.l   @r0, r0             /* r0 = rundom */
    tst     r0, r0              /* rundom == TACP_KERNEL(=0) */     
    bf      _dispatch_r_1       /* 桼ɥᥤʤ_dispatch_r_1 */
    mov.b   @(TCB_svclevel, r1), r0  /* r0 = svclevel */
    tst     r0, r0              /* svclevel == 0 ? */
    bf      _dispatch_r_1       /* ĥӥƽФʤ_dispatch_r_1 */

    mov.l  _call_texrtn_dis,r1  /* 㳰롼θƤӽФ */
    jmp    @r1
     nop
_dispatch_r_1:
    rts
     nop

/*
 * ǥѥåưϡprc_support.S
 */
    .global _start_dispatch
_start_dispatch:
    /*
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     * ʳߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
     *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
     *
     *  prc_initializeǡlock_flagtrueˡsaved_iipmIIPM_ENAALL
     *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     *  ޤinitialize_taskdisdspfalse˽Ƥ뤿ᡤǥ
     *  ѥåľ֤ˤʤäƤ롥
     *  
     *  Ǥϡr7_bank10ꥢʤϡͥγ
     *  ߤ򥵥ݡȤ硤ΤǤΥå󥿥ƥѤ
     *  åǤ뤿ᡤr7_bank10ξ֤ǥͥγߤ
     *  ȡåξ񤭤ȯƤޤǤ롥
     */
    bra    _dispatcher_0
     nop

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl _exit_and_dispatch
_exit_and_dispatch:
    /* ǥѥåΡdispatcherˤ */

/*
 * ǥѥå
 */
_dispatcher:
#ifdef LOG_DSP_ENTER
    mov.l _log_dsp_enter_dis, r1 /* ϴؿ */
    mov.l _p_runtsk_dis, r2      /*       */
    jsr   @r1
     mov.l  @r2,r4 
#endif /* LOG_DSP_ENTER */
_dispatcher_0:
    /*
     *  Υ롼ϡƥȡCPUå֡ǥѥå
     *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
     *  롥
     *
     *  ʤr7_bank10lock_flagtruedisdspfalsedspflg
     *  truesaved_iipmIIPM_ENAALLȤʤäƤ롥¹ԺƳϤؤ⤳
     *  ξ֤Τޤʬ롥
     *
     *  ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     *  ƤԲʬ˹Ԥɬפ롥
     *  ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     *  ᡤBLӥåȤ1˥åȤơͥγߤػߤ롥
     */
    mov.l  _p_schedtsk_dis,r12  /* r0 <- p_schedtsk                 */
    mov.l  @r12,r0             
    mov.l  _p_runtsk_dis,r2
    mov.l  r0,@r2               /* schedtskruntsk               */
    cmp/eq #0,r0                /* schedtsk 뤫              */
    bt     _dispatcher_1        /* ʤ_dispatcher_1          */
    mov.l  _mask_md_bl_dis,r1   /* BLӥåȤ1ˡ߶ػߡ    */
    ldc    r1,sr
    mov.l  @(TCB_ssp,r0),r15     /* TCB饿å      */
    xor    r1,r1                /* r7_bank10                    */
    ldc    r1,r7_bank

	mov.l	@(TCB_p_tinib,r0), r1	    /* r1 = p_runtsk->p_tinib */
	mov.l	@(TINIB_p_dominib,r1), r2   /* r2 = p_runtsk->p_tinib->p_dominib */
	mov.l	_rundom_dis, r3             /* r3 = &rundom */
	mov.l	@(DOMINIB_domptn,r2), r4    /* r4 = domptn */
    mov     r0, r1                      /* r0 */
	mov.b	@(TCB_svclevel,r0), r0      /* r0 = p_runtsk->svclevel */
	tst     r0, r0                      /* p_runtsk->svclevel0 */
	bf/s    _dispatcher_3               /* p_runtsk->svclevel0Ǥʤʤ鼡̿򥹥å */
    mov     r1, r0                      /* r0 */
    /*
     *  rundom = p_runtsk->p_tinib->p_dominib->domptn
     */
    mov.l   r4, @r3
    bra     _dispatcher_4
    nop
_dispatcher_3:
    mov     #0, r1
    mov.l   r1, @r3       /* rundom = 0(svclevel0Ǥʤ) */
_dispatcher_4:
	/*
     *  ASIDڤؤ
     *  ͥɥᥤξASIDڤؤ
	 */
    mov.l   @(DOMINIB_asid, r2), r4
    mov.l   _pteh_dis, r3
    mov.l   r4, @r3

_dispatcher_5:
    mov.l  _mask_md_ipm_dis,r1  /* BLӥåȤ0                    */
    ldc    r1,sr                /* ʥͥγߵġ   */

#ifdef LOG_DSP_LEAVE
    mov   r0, r8                 /* r0ϥå쥸ʤΤ r8˥ԡ */
    mov.l _log_dsp_leave_dis, r1 /* ϴؿ */
    jsr   @r1
     mov   r0, r4                /*       */
    mov  r8, r0                  /* r0TCBؤΥݥ󥿤᤹ */    
#endif /* LOG_DSP_LEAVE */
    mov.l  @(TCB_pc,r0),r1      /* TCB¹ԺƳϤ        */
    jmp    @r1 
     nop
_dispatcher_1:
    /* ߥǥͤɤ߹ΤϸΨΤǻѰդ
     * r8  : ߶ػߤΤSR
     * r9  : ԤSR
     * r10 : reqflg
     * r11 : 0x01
     * r12 : 0x00
     * r13 : sleepSRξ
     * r14 : lock_flag
     */
#ifdef NO_SLEEP
    mov.l  _mask_md_dis,r9      /* ԤSR           */
#else
    mov.l  _mask_md_bl_dis,r9   /* ԤSR           */
#endif /* NO_SLEEP */
    mov.l  _reqflg_dis,r10
    xor    r12,r12
    mov.l  _lock_flag_dis,r14
    mov.l  r12,@r14             /* CPUå֤ */

    /*
     *  ǳߥ⡼ɤڤ괹Τϡȯ߽
     *  ˤɤΥåȤȤβȡߥϥɥ
     *  ΥǥѥåɻߤȤĤΰ̣롥
     *  ߥ⡼ɤˤ뤿ᡤr7_bank1  1 ˤơå
     *  ƥȤѹ롥κݡͥγߤ
     *  ʤ褦BLӥåȤ'1'Ȥ롥
     */
    mov.l  _mask_md_bl_dis,r8   /* ߶ػߤSR             */
    ldc    r8,sr
    mov.l  _kernel_istkpt_dis,r11
    mov.l  @r11,r15
    mov    #0x01,r11
    ldc    r11,r7_bank         /* r7_bank1 1ˤƳ߾֤ */
_dispatcher_2:
     /*
      *  ߵĸsleep̿¹Ԥȡߵ̿μ¹
      *  ׵᤬äƤ硤ߵ̿μ¹Ԥȶ˳ߤ
      *  դ줽ˡreqflgΥåǤϤʤ sleep 
      *  äƤޤ
      *  ϡߤεĤ sleep ֤ؤΰܹԤȥߥå˼
      *  ԤǤʤȤ˵롥
      *  Τᡤsleep ¹ľ SR ѹǤ BL ӥåȤ'1'ꤹ
      *  뤳ȤǡߤεĤ sleep ֤ؤΰʹߤ򥢥ȥߥå˼¹
      *  롥
      *  ldc r9,sr ǤBLӥåȤåȤ뤿ᡤߤϼդ
      *  ꡼ץ⡼ɤ˰ܹԤ롥꡼ץ⡼ϡBLӥåȤ1Ǥ
      *  ߤդ뤿(SH7709ϡɥޥ˥奢 8-10)꡼
      *  ץ⡼ɤؤΰܹľ˳ߤե꡼ץ⡼ɤ롥
      */
               
    ldc    r9,sr               /* ߤε                   */
#ifndef NO_SLEEP
    sleep                      /* Ԥ                       */
#else
    /* 
     * ǥѥåɬפʾBLӥåȤ'1'Ȥ롥
     */
    ldc    r8,sr
#endif /* NO_SLEEP */
    mov.l  @r10,r7             /* r7 <- reqflg                     */
    tst    r7,r7               /* reqflg  falseʤ              */
    bt     _dispatcher_2       /* dispatcher_2                   */

    ldc    r12,r7_bank         /* r7_bank1 򥯥ꥢ                */
    mov.l  r12,@r10            /* reqflg  false                */

    /*
     *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
     *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
     *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
     *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
     *  Ф褤
     */
    mov.l  _mask_md_ipm_dis, r8 /* BLӥåȤ'0' */
    ldc    r8,sr               
    mov.l  _saved_iipm_dis, r10
    mov.l  r11,@r14            /* CPUå֤ */
    bra    _dispatcher_0
     mov.b r12,@r10            /* saved_iipm0ˤ */

    .align 4
#ifdef TOPPERS_SUPPORT_OVRHDR
_ovrtimer_start_dis:
    .long _ovrtimer_start
_ovrtimer_stop_dis:
    .long _ovrtimer_stop
#endif /* TOPPERS_SUPPORT_OVRHDR */
_dispatch_r_dis:
    .long _dispatch_r
_p_runtsk_dis:
    .long _p_runtsk
_enatex_mask_dis:
    .long TCB_enatex_mask
_ipmflg_dis:
    .long _ipmflg
_call_texrtn_dis:
    .long _call_texrtn_stask
_p_schedtsk_dis:
    .long _p_schedtsk
_kernel_istkpt_dis:
    .long __kernel_istkpt
_mask_md_ipm_dis:
    .long (0x40000000 + INT_IPM(TMIN_INTPRI))
_mask_md_dis:
    .long 0x40000000
_mask_md_bl_dis:
    .long 0x50000000
_reqflg_dis:
    .long  _reqflg
_lock_flag_dis:
    .long _lock_flag
_saved_iipm_dis:
    .long _saved_iipm
save_fpureg_data dis
#ifdef LOG_DSP_ENTER
_log_dsp_enter_dis:
    .long _log_dsp_enter
#endif /* LOG_DSP_ENTER */
#ifdef LOG_DSP_LEAVE
_log_dsp_leave_dis:
    .long _log_dsp_leave
#endif /* LOG_DSP_LEAVE */
_rundom_dis:
    .long _rundom
_pteh_dis:
    .long MMU_PTEH

 
/*
 *  Exception 600 vector
 *  ߤȯȼ¹Ԥ롣
 *
 *
 *  SH34ϳߤȯȤ٤VBR+0x600Ϥץ¹Ԥ뤿ᡢ
 *  ֤롼Ǥޤåڤؤ쥸¸,IPM,
 *  װȽԤθBLӥåȤ0ˤƳߥϥɥƤɬ
 *  롣
 *  װбߥϥɥγϤinh_tbl[]Ͽ
 *  ƸƤӽФեåȤη׻ϡװ쥸롥
 *  װ쥸INTEVTINTEVT2ब¸ߤ뤬ɤѤ뤫
 *  ץåη˻ꤹ롥
 *  ͥ٥ޥϡint_iipm_tbl[]SRꤹ롥
 *
 *  reqflg å˳ߤػߤʤȡreqflg å
 *  ˵ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥ
 *  ѥåʤ
 *
 */

    .org    0x0600         /* _BASE_VBR + 0x0600Ϥ */
    .align 2
    .global _interrupt_vec
_interrupt_vec:
    /*
     *  㳰ȯư⡼ɤ桼⡼ɤʤСåݥ󥿤򥷥ƥ
     *  åڤؤ롥
     *  åؤ򤹤˥åݥ󥿤ڤؤΤϡåؤ
     *  TLB˥ɤƤ桼åΰϰϤۤƤޤ
     *  TLBߥ㳰ȯȡåؤ㳰ޥ֡BL==1
     *  Ǥ뤿ᡤꥻåȽ˥פƤޤǤ롥
     *  ǡ쥸Х󥯤1Ǥ뤳ȡġSH4 HRP2ͥϡ㳰
     *  ޥ֤ǤΤߥ쥸Х1Ȥ㳰ޥƤʤ֤Ǥϡ
     *  R7ʳΥ쥸Х1Υ쥸˲ǽǤ뤳Ȥ顤
     *  R0Ѥ뤳Ȥʤ
     *  ޤR15Ѥ뤳ȤǽǤ뤬ƥॹåؤڤؤ
     *  ʤˡR15SGR뤿ᡤǤʤȹͤ
     */
    stc     ssr, r0             /* r0 = 㳰ȯľSR */
    shll    r0                  /* SRMSB̵ */
    shll    r0                  /* SRMSBμΥӥåȤMD -> ø⡼ɡMD==1ˤʤT=1 */
    bt      _interrupt_vec_0  /* ȯø⡼ɤʤ饹å */
    mov.l   _p_runtsk_ret, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _interrupt_vec_0  /* ¹ǤʤХå: TODO: 桼⡼ɤǥ¹ǤʤȤϵꤦΤ */
    mov.l   r15, @(TCB_usp, r0)     /* usp¸ */
    /* ǡusp¸Τϡ㳰䤹뤿 */
    mov.l   @(TCB_ssp, r0), r15   /* ssp򥻥å */
_interrupt_vec_0:
    stc.l   sgr,@-r15
    stc.l  spc,@-r15       /* ¿ųߤȾäƤޤΤ        */
    sts.l  pr,@-r15        /* spc,pr,ssr,gbr,macl,mach򥹥å¸    */
    stc.l  ssr,@-r15    
    stc.l  gbr,@-r15                    
    sts.l  macl,@-r15                    
    sts.l  mach,@-r15                                                    
    stc.l  r0_bank,@-r15   /* r0r7򥹥å¸   */
    stc.l  r1_bank,@-r15
    stc.l  r2_bank,@-r15
    stc.l  r3_bank,@-r15
    stc.l  r4_bank,@-r15
    stc.l  r5_bank,@-r15
    stc.l  r6_bank,@-r15
    stc.l  r7_bank,@-r15
    save_scratch_fpureg int
    tst    r7,r7                 /* ȯΥƥȤȽ  */
    bf/s   _interrupt_vec_1      /* 㳰/ߥϥɥʤ饸   */
     add    #0x01,r7             /* ߤΥͥȲ򥤥󥯥*/
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   r7, @-r15
    mov.l   _ovrtimer_stop_int, r0
    jsr     @r0
    nop
    mov.l   @r15+, r7
#endif /* TOPPERS_SUPPORT_OVRHDR */
    mov    r15,r1
    mov.l  _kernel_istkpt_int,r2 /* 󥿥ƥѥå    */
    mov.l  @r2,r15              
    mov.l  r1,@-r15              /* Υåݥ󥿤¸          */
_interrupt_vec_1:
    mov.l  _intevt_int,r0        /* װ쥸ֹ    */
    mov.l  @r0,r4                /*                               */
    mov.l  r4, @-r15             /* ֹ򥹥å¸          */
    index_intno r4               /* եåȤ                  */
    mov.l  _int_iipm_tbl_int,r0  /* ͥ٥ޥͤ      */
    mov.l  @(r0,r4),r5

#if TMIN_INTPRI != -15
    /*
     * ͥγߤȽ
     *
     * SRꤹIPMͤ -TMIN_INTPRI ʾʤ饫ͥγ
     * Ƚǡ
     */
    mov    r5, r0
    and    #0xf0, r0
    mov    #INT_IPM(TMIN_INTPRI), r2
    cmp/hi r2, r0
    bt     _nonkernel_int
#endif /* TMIN_INTPRI != -15 */
    /*
     * ͥγߥϥɥ
     */
    mov.l  _inh_tbl_int,r0       /* ߥϥɥΥɥ쥹    */
    mov.l  @(r0,r4),r2
    ldc    r2,r2_bank            /* Х0ڤؤ뤿ᥳԡ       */
    ldc    r5,sr                 /* ʹ߳ߤդ롣      */

#ifdef LOG_INH_ENTER
    mov.l @r15, r4               /* ֹ              */
    mov.l  r2, @-r15             /* ߥϥɥΥɥ쥹¸      */
    mov.l _log_inh_enter_int, r1 /* ϴؿ                        */
    jsr   @r1
     nop
    mov.l  @r15+, r2             /* ߥϥɥΥɥ쥹      */
    mov    r15, r4               /* default_int_handlerΤΰ     */
#endif /* LOG_INH_ENTER */

    jsr    @r2                   /* ߥϥɥ                  */
     nop

    mov.l @r15+, r4              /* ֹ                    */
#ifdef LOG_INH_LEAVE
    mov.l _log_inh_leave_int, r1 /* ϴؿ                        */
    jsr  @r1
     nop
#endif /* LOG_INH_LEAVE */

    /*
     * ߥϥɥи
     */
_ret_int:
    /*
     * ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     * ƤԲʬ˹Ԥɬפ롥
     * ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     * ᡤBLӥåȤ1˥åȤơͥγߤػߤ롥
     */
    mov.l  _mask_md_bl_ret,r0    /* BLӥå  1                        */
    ldc    r0,sr                 /* ߶ػ                           */
    stc    r7_bank,r7            /* 㳰/ߤΥͥȲǥ*/
    dt     r7
    ldc    r7,r7_bank
    tst    r7,r7                 /* 褬󥿥ƥȤʤ餹 */
    bf     _ret_int_1            /* ꥿                               */
    mov.l  @r15, r15             /* 褬ʤΤǥå᤹     */
    mov.l  _reqflg_ret,r4        /* reqflgΥå                       */
    mov.l  @r4,r1
    tst    r1,r1                 /* reqflgfalseʤret_int_0           */
    bt     _ret_int_0
    xor    r1,r1                 /* reqflgΥꥢΤr10          */
    mov.l  _mask_md_ipm_ret,r0   /* BLӥå  0                        */
    ldc    r0, sr                /* ͥγߵ             */
    bra    _ret_int_2;
     mov.l  r1,@r4               /* reqflg򥯥ꥢ                         */

_ret_int_0:
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   _ovrtimer_start_int, r0
    jsr     @r0
    nop
#endif /* TOPPERS_SUPPORT_OVRHDR */
_ret_int_1:
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ褦
     *  롥ͥ٥ޥϡRTE̿ˤ긵ͤ뤿ᡤ
     *  lock_flagfalseˤƤФ褤lock_flagfalseˤΤϡ
     *  CPUå֤Τޤ޳ߥϥɥ餫äкˡ
     */
    mov.l _lock_flag_ret, r0
    xor   r1,r1
    mov.l  r1,@r0
    restore_scratch_fpureg
    mov.l  @r15+,r7                /* ߸                 */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    /*
     *  SGR򥹥åsstk or istkˤ
     *  åݥ󥿡usp, ispˤSGR
     *  褬桼⡼ɤʤSGRˤusp¸Ƥ뤿̤ưǤ롥
     *  褬ø⡼ɤʤSGRˤSGRsp¸Ƥ뤿spѲʤ
     */
    ldc.l   @r15+, r1_bank  /* r1_bank = sgr */
    ldc     r0, r0_bank /* r0΢쥸¸ */
    mov.l   _p_runtsk_ret, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _ret_int_1_2  /* ¹ǤʤХå */
    mov.l   r15, @(TCB_ssp, r0)     /* ssp */
_ret_int_1_2:
    stc     r0_bank, r0 /* r0 */
    stc     r1_bank, r15     /* sp */
    rte
     nop

_ret_int_2:
    /*
     *  ؤϡCPU㳰ϥɥνиʬƤ롥
     *
     *  Ǥϡ褬Ǥꡤåϡå
     *  å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ͥγߤػߤ֤ȤʤäƤ롥
     */
    /*
     *  CPUå֤˰ܹԤ롥
     *  ͥγߤϤǤ˶ػߤƤΤǡlock_flag  
     *  true Ȥ롥
     */
    mov.l _lock_flag_ret, r2    /* lock_flagtrue */
    mov   #0x01,r1
    mov.l r1,@r2
    /*
     *  ͥ٥ޥ֡TIPM_ENAALLˤꤹ
     *  ǤCPUå֤ʤΤǡsaved_iipm0Ȥ롥
     */
    mov   #0,r0
    mov.l _saved_iipm_ret, r1
    mov.b r0,@r1
    /*
     *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
     *  ǥѥåԤʤΥåɬפʤΤϡ㳰
     *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
     *  reqflgtrueˤ뤿Ǥ롥
     */
    mov.l  _p_runtsk_ret,r1     /* r0 <- p_runtsk               */
    mov.l  @r1,r0           
    mov.l  _dspflg_ret,r2       /* dspflgfalseʤret_int_3 */
    mov.l  @r2,r3
    tst    r3,r3
    bt     _ret_int_3    
    mov.l  _p_schedtsk_ret,r4   /* r5 <- schedtsk                */ 
    mov.l  @r4,r5
    cmp/eq r0,r5                /* runtsk  schedtsk      */
    bt     _ret_int_3           /* Ʊʤret_int_3           */
    save_callsaved_fpureg_int
    mov.l  r14,@-r15            /* ĤΥ쥸¸          */
    mov.l  r13,@-r15
    mov.l  r12,@-r15
    mov.l  r11,@-r15
    mov.l  r10,@-r15
    mov.l  r9,@-r15
    mov.l  r8,@-r15
    mov.l  r15,@(TCB_ssp,r0)     /* åTCB¸ 60ʲʤOK*/
    mov.l  _ret_int_r_ret,r1    /* ¹ԺƳϤ¸             */
    bra    _dispatcher
     mov.l  r1,@(TCB_pc,r0)


_ret_int_r:
    mov.l  @r15+,r8
    mov.l  @r15+,r9
    mov.l  @r15+,r10
    mov.l  @r15+,r11
    mov.l  @r15+,r12
    mov.l  @r15+,r13
    mov.l  @r15+,r14
    restore_callsaved_fpureg_int
_ret_int_3:
#ifdef TOPPERS_SUPPORT_OVRHDR
    mov.l   r0, @-r15
    mov.l   _ovrtimer_start_int, r0
    jsr     @r0
    nop
    mov.l   @r15+, r0
#endif /* TOPPERS_SUPPORT_OVRHDR */
    /*
     *  㳰롼εư
     *  ret_int_r  dispatcher ƤӽФ뤿ᡤtcbΥɥ쥹r0
     *  äƤ롥
     *  ʤߤνиǥåȯʤϥǥѥå
     *  ̤餺 ret_int ľ ret_int_1 
     */
    mov    r0,r1
    mov    #TCB_enatex, r0
    mov.b  @(r0,r1),r0
    mov.l  _enatex_mask_ret,r2
    tst    r0,r2
    bt/s   _ret_int_4           /* enatex  false ʤret_int_4  */
     mov.l  @(TCB_texptn,r1),r0 /* texptn                   */
    tst    r0,r0
    bt     _ret_int_4           /* texptn  0ʤret_int_4       */
    mov.l  _ipmflg_ret,r2       /* ipmflg  false ʤret_int_4  */
    mov.l  @r2, r0
    tst    r0, r0
    bt     _ret_int_4

    mov.l   _rundom_ret, r0     /* r0 = &rundom */
    mov.l   @r0, r0             /* r0 = rundom */
    tst     r0, r0              /* rundom == TACP_KERNEL(=0) */     
    bt      _ret_int_r_ker      /* ͥɥᥤʤ_ret_int_r_ker */
    nop
    mov     r1, r0
    mov     #TCB_priv_mode, r2
    mov.b   @(r0, r2), r1       /* r1 = p_runtsk->priv_mode */
    tst     r1, r1              /* priv_mode == 0 */     
    bf      _ret_int_4          /* ø⡼ɤʤ_ret_int_4 */
    
    /*
     *  桼Υ㳰롼إפ򤹤
     *  ߶ػ߾֡BL == 1˥쥸Х0RB == 0ø⡼ɼ¹MD == 1
     *  R0 = p_runtsk
     */
    mov.l   _mask_md_bl_ret, r1
    ldc     r1, sr

    mov.l   _prepare_texrtn_utask_ret, r1   /* 桼Υ㳰 */
    jsr     @r1
    nop
    bra     _ret_int_4
    nop

_ret_int_r_ker:
    mov.b   @(TCB_svclevel, r1), r0  /* r0 = svclevel */
    tst     r0, r0              /* svclevel == 0 ? */
    bf      _ret_int_4
    mov.l _call_texrtn_ret,r1   /* 㳰롼θƤӽФ     */
    jsr   @r1
     nop

_ret_int_4:
    mov.l  _lock_flag_ret, r2  /* lock_flagfalse */
    xor    r0,r0 
    mov.l  r0,@r2
    restore_scratch_fpureg
    mov.l  @r15+,r7            /* spc,pr,ssr,å쥸 */
    mov.l  @r15+,r6
    mov.l  @r15+,r5
    mov.l  @r15+,r4
    mov.l  @r15+,r3
    mov.l  @r15+,r2
    mov.l  @r15+,r1
    mov.l  _mask_md_bl_ret,r0
    ldc    r0,sr               /* BL1                             */
    mov.l  @r15+,r0
    lds.l  @r15+,mach
    lds.l  @r15+,macl
    ldc.l  @r15+,gbr
    ldc.l  @r15+,ssr
    lds.l  @r15+,pr
    ldc.l  @r15+,spc
    /*
     *  SGR򥹥åsstk or istkˤ
     *  åݥ󥿡usp, ispˤSGR
     *  褬桼⡼ɤʤSGRˤusp¸Ƥ뤿̤ưǤ롥
     *  褬ø⡼ɤʤSGRˤSGRsp¸Ƥ뤿spѲʤ
     */
    ldc.l   @r15+, r1_bank  /* r1_bank = sgr */
    ldc     r0, r0_bank /* r0΢쥸¸ */
    mov.l   _p_runtsk_ret, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _ret_int_5  /* ¹ǤʤХå */
    mov.l   r15, @(TCB_ssp, r0)     /* ssp */
_ret_int_5:
    stc     r0_bank, r0 /* r0 */
    stc     r1_bank, r15     /* sp */
    rte
     nop

#if TMIN_INTPRI != -15
    /*
     * ͥγ
     */
_nonkernel_int:
    mov.l  _inh_tbl_int,r0       /* ߥϥɥΥɥ쥹    */
    mov.l  @(r0,r4),r2
    mov    r15, r4               /* default_int_handlerΤΰ     */
    ldc    r2,r2_bank            /* Х0ڤؤ뤿ᥳԡ       */
    ldc    r5,sr                 /* ʹ߳ߤդ롣      */

#ifdef LOG_INH_ENTER
    mov.l @r15, r4               /* ֹ              */
    mov.l  r2, @-r15             /* ߥϥɥΥɥ쥹¸      */
    mov.l _log_inh_enter_int, r1 /* ϴؿ                        */
    jsr   @r1
     nop
    mov.l  @r15+, r2             /* ߥϥɥΥɥ쥹      */
    mov    r15, r4               /* default_int_handlerΤΰ     */
#endif /* LOG_INH_ENTER */

    jsr    @r2                   /* ߥϥɥ                  */
     nop

    mov.l @r15+, r4              /* ֹ                    */
#ifdef LOG_INH_LEAVE
    mov.l _log_inh_leave_int, r1 /* ϴؿ                        */
    jsr  @r1
     nop
#endif /* LOG_INH_LEAVE */

    /*    
     * ͥγߤνи
     */
_ret_nonkernel_int:
    /*
     * ߤΥͥʿ r7_bank1 ȥåݥ(r15)
     * ƤԲʬ˹Ԥɬפ롥
     * ñ˳ߤػߤǤϡͥγߤػߤǤʤ
     * ᡤBLӥåȤ1˥åȤơͥγߤػߤ롥
     */
    mov.l  _mask_md_bl_ret,r0    /* BLӥå  1                        */
    ldc    r0,sr                 /* ߶ػ                           */
    stc    r7_bank,r7            /* 㳰/ߤΥͥȲǥ*/
    dt     r7
    ldc    r7,r7_bank
    tst    r7,r7                 /* 褬󥿥ƥȤʤ餹 */
    bf     _ret_int_1            /* ꥿                               */
    bra    _ret_int_1            /* 褬ʤΤǥå᤹     */
     mov.l  @r15, r15            /* ꥿                               */
#endif /* TMIN_INTPRI != -15 */

    .align  4
#ifdef TOPPERS_SUPPORT_OVRHDR
_ovrtimer_start_int:
    .long _ovrtimer_start
_ovrtimer_stop_int:
    .long _ovrtimer_stop
#endif /* TOPPERS_SUPPORT_OVRHDR */
_kernel_istkpt_int:
    .long __kernel_istkpt
_intevt_int:
#ifdef USE_INTEVT2
    .long  INTEVT2
#else
    .long  INTEVT
#endif /* USE_INTEVT2 */
_int_iipm_tbl_int:
    .long  _int_iipm_tbl
_inh_tbl_int:
    .long  _inh_tbl

_mask_md_ipm_ret:
    .long  (0x40000000 + INT_IPM(TMIN_INTPRI))
_lock_flag_ret:
    .long  _lock_flag
_mask_md_bl_ret:
    .long  0x50000000
_reqflg_ret:
    .long  _reqflg
_saved_iipm_ret:
    .long  _saved_iipm
_p_runtsk_ret:
    .long  _p_runtsk
_dspflg_ret:
    .long  _dspflg
_p_schedtsk_ret:
    .long  _p_schedtsk
_ret_int_r_ret:
    .long _ret_int_r
_enatex_mask_ret:
    .long TCB_enatex_mask
_ipmflg_ret:
    .long _ipmflg
_call_texrtn_ret:
    .long _call_texrtn_stask
_rundom_ret:
    .long _rundom
_prepare_texrtn_utask_ret:
    .long _prepare_texrtn_utask
#ifdef LOG_INH_ENTER
_log_inh_enter_int:
    .long _log_inh_enter
#endif /* LOG_INH_ENTER */
#ifdef LOG_INH_LEAVE
_log_inh_leave_int:
    .long _log_inh_leave
#endif /* LOG_INH_LEAVE */
save_fpureg_data int

/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    .globl _call_exit_kernel
_call_exit_kernel:
    mov.l _mask_md_ipm_exit, r0
    ldc   r0,sr    
    mov.l _kernel_istkpt_exit, r1
    mov.l @r1,r15
    mov.l _exit_kernel_exit,r0
    jmp   @r0
     nop

    .align 4
_mask_md_ipm_exit:
    .long 0x400000f0
_kernel_istkpt_exit:
    .long __kernel_istkpt
_exit_kernel_exit:
    .long _exit_kernel


/*
 *  Ԥ
 */
    .globl _sil_dly_nse
_sil_dly_nse:
    mov.l  _sil_dly_tim1, r1
    add    r1, r4
    cmp/pl r4
    bt     _sil_dly_nse1
    rts
     nop
_sil_dly_nse1:
    mov.l  _sil_dly_tim2, r1
    add    r1, r4
    cmp/pl r4
    bt     _sil_dly_nse1
    rts
     nop   
    .align 4
_sil_dly_tim1:
    .long  -SIL_DLY_TIM1
_sil_dly_tim2:
    .long  -SIL_DLY_TIM2
