/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 1598 2009-06-29 09:43:33Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼APSH4ѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "pdic/sh/sh_scif.h"
#include "apsh4.h"
#include "task.h"
#include "memory.h"

#ifdef ROM_BOOT
uint32_t __dummy = 1;
#endif

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
    /*
     *  ץå¸ν
     */
    prc_initialize();

    target_mmu_initialize();

    /*
     * СʡѤΥꥢ륳ȥν
     */
    sh_scif_init(TARGET_PUTC_PORTID);    
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
    /*
     *  ץå¸νλ
     */
    prc_terminate();

    /*
     *  ȯĶ¸νλ
     */
    apsh4_exit();

    /*
     * ˤʤ
     */
    while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char c)
{
    if (c == '\n') {
        sh_scif_pol_putc('\r', TARGET_PUTC_PORTID);
    }
    sh_scif_pol_putc(c, TARGET_PUTC_PORTID);
}

/*
 *  ΰ褬桼åΰ˴ޤޤƤ뤫Υå
 *
 *  ƬϤbaseǥsizeΥΰ褬p_tcbǻꤵ륿
 *  Υ桼åΰ˴ޤޤƤtrueǤʤ
 *  false֤
 *
 *  ΰƬϤ桼åޤǤĹ
 *  ΰΥ礭ġ
 *  桼åΥ⾮Сΰϡ
 *  桼åϰǤ롥
 *
 */
bool_t
within_ustack(const void *base, SIZE size, TCB *p_tcb)
{
    SIZE stk_bottom = (SIZE)(p_tcb->p_tinib->tskinictxb.stk_bottom);
    SIZE len = stk_bottom - (SIZE)base;

    return ((SIZE)base < stk_bottom
            && len >= size
            && len <= (SIZE)(p_tcb->p_tinib->tskinictxb.stksz));
}

/*
 *  桼Υ㳰ƤӽФ˻Ѥ륹å­ʤ
 */
bool_t
i_check_tex_runtsk()
{
    SIZE ustk_top = (SIZE)(p_runtsk->tskctxb.usp);

    if(!PROBE_STACK((void *)(ustk_top - USRTEX_STKSZ), 
                USRTEX_STKSZ)){
        return (true);
    }

    return (false);
}  

