/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

#ifndef _TOPPERS_TARGET_MEM_H_
#define _TOPPERS_TARGET_MEM_H_

/*
 *  ꡼˴ؤ
 *  桼⡼ɤǥǤΰϡ
 *  0x0000 0000 - 0x7FFF FFFF
 */
#ifdef ROM_BOOT

/*
 *  ROM֡ȥ⡼ɤξ
 *  textΰFLASHʥꥢ0: 0x0000 0000 - 0x003F FFFF
 *  dataΰSDRAMʥꥢ3: 0x0C00 0000 - 0x0DFF FFFF
 */
#define TEXT_START_ADDRESS 0x00000000
#define TEXT_REGION_SIZE   0x00400000
#define DATA_START_ADDRESS 0x0C000000
#define DATA_REGION_SIZE   0x02000000

#else /* ROM_BOOT */

/*
 *  RAM֡ȥ⡼ɤξ
 *  textΰdataΰ϶SDRAMʥꥢ3: 0x0C00 0000 - 0x0DFF FFFF
 *  textΰdataΰ϶SRAMʥꥢ0: 0x0000 0000 - 0x0003 FFFF
 */
#if 0 // SDRAMѻ
#define TEXT_START_ADDRESS 0x0C000000
#define TEXT_REGION_SIZE   0x00100000
#define DATA_START_ADDRESS 0x0C100000
#define DATA_REGION_SIZE   0x01F00000
#else // SRAMѻ
#define TEXT_START_ADDRESS 0x00000000
#define TEXT_REGION_SIZE   0x00030000
#define DATA_START_ADDRESS 0x00030000
#define DATA_REGION_SIZE   0x00010000
#endif

#endif /* ROM_BOOT */

#include "target_mmu.h"

#endif /* _TOPPERS_TARGET_MEM_H_ */

