/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2011-2012	by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 1598 2009-06-29 09:43:33Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼 ֥APSH4A
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#define CAST(type, val)	(val)		/* 㥹ȤԤޥ */

/*
 *  ֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"

/*
 *  ٥ΥåȰ¸ν
 *
 *  ȥåץ⥸塼ǡν˸ƤӽФ롥
 */
    .text
    .globl _hardware_init_hook
_hardware_init_hook:
#ifdef ROM_BOOT
	/*
	 * ꥢ3DDR֤ˤ¾LBSC֤
	 */
	mov.l _lbsc_mmselr_addr, r1
	mov.l _lbsc_mmselr_val, r2
	mov.l r2, @r1

	/*
	 * եå(CS0)
	 */
	mov.l _lbsc_cs0bcr_addr, r1
	mov.l _lbsc_cs0bcr_val, r2
	mov.l r2, @r1
	mov.l _lbsc_cs0wcr_addr, r1
	mov.l _lbsc_cs0wcr_val, r2
	mov.l r2, @r1

	/*
	 *  DDR SDRAM 
     *  256Mbit(16Mx16bit) :CL=2.5, 8192REFA @ 64mS MCLK=160MHz@6.25nS
 	 */
	/*
	 *  DDR Dummy Read
	 */
	mov.l _ddr_base_addr, r1
	mov.l @r1, r2
	/*
	 *  dummy write for Little endian
	 */
	mov.l _ddr_dmwr_l_addr, r1
	mov.l _ddr_dmwr_l_val,  r2
	mov.l r2, @r1

	/*
	 *  DCE=1:DDR,DLL=1 enable,!**BANK CLOSE MODE**!
	 */
	mov.l _ddrif_min_h_addr, r1
	mov.l _ddrif_min_h_val, r2
	mov.l r2, @r1
	mov.l _ddrif_min_l_addr, r1
	mov.l _ddrif_min_l_val, r2
	mov.l r2, @r1

	/*
	 *  SPLIT=3:16Mx16bit	
	 */
	mov.l _ddrif_sdr_h_addr, r1
	mov.l _ddrif_sdr_h_val, r2
	mov.l r2, @r1
	mov.l _ddrif_sdr_l_addr, r1
	mov.l _ddrif_sdr_l_val, r2
	mov.l r2, @r1

	/*
	 *   WR  =0:W-R min cycle 3,RW=0:R-W min cycle 3
     *    SRFC=:12cycle=75.0nS, Trfc=72nS
     *    SWR =: 3cycle=18.7nS, Twr =15nS
     *    SRRD=: 2cycle=12.5nS, Trrd=12nS
     *    SRAS=: 7cycle=43.7nS, Tras=42nS
     *    SRC =:10cycle=62.5nS, Trc =60nS
     *    SCL =0: CL=2.5 only
     *    SRCD=: 3cycle=18.7nS, Trcd=18nS
     *    SRP =: 3cycle=18.7nS, Trp =18nS
	 */
	mov.l _ddrif_str_h_addr, r1
	mov.l _ddrif_str_h_val, r2
	mov.l r2, @r1
	mov.l _ddrif_str_l_addr, r1
	mov.l _ddrif_str_l_val, r2
	mov.l r2, @r1	

	/*
	 *  DESELECT command issue
	 */
	mov.l _ddrif_scr_h_addr, r1
	xor   r2,r2
	mov.l r2, @r1
	mov.l _ddrif_scr_l_addr, r1
	mov.l _ddrif_scr_l_val_3, r2
	mov.l r2, @r1	

	/*
	 *  PREALL   command issue
	 */
	mov.l _ddrif_scr_h_addr, r1
	xor   r2,r2
	mov.l r2, @r1
	mov.l _ddrif_scr_l_addr, r1
	mov.l _ddrif_scr_l_val_2, r2
	mov.l r2, @r1	

	/*
	 *  DDR-EMRS write
	 */
	mov.l _ddr_sdmr1_addr, r1          
	mov.l _ddr_sdmr1_val, r2
	mov.w r2, @r1

	/*
	 *  DDR-MRS write
	 */
	mov.l _ddr_sdmr2_addr, r1
	mov.l _ddr_sdmr2_val, r2
	mov.w r2, @r1	
    
	/*
	 *  PREALL   command issue
	 */
	mov.l _ddrif_scr_h_addr, r1
	xor   r2, r2
	mov.l r2, @r1
	mov.l _ddrif_scr_l_addr, r1
	mov.l _ddrif_scr_l_val_2, r2
	mov.l r2, @r1	

	/*
	 *  REFA 1   command issue
	 */
	mov.l _ddrif_scr_h_addr, r1
	xor   r2, r2
	mov.l r2, @r1
	mov.l _ddrif_scr_l_addr, r1
	mov.l _ddrif_scr_l_val_4, r2
	mov.l r2, @r1	

	/*
	 *  REFA 2   command issue
	 */
	mov.l _ddrif_scr_h_addr, r1
	xor   r2, r2
	mov.l r2, @r1
	mov.l _ddrif_scr_l_addr, r1
	mov.l _ddrif_scr_l_val_4, r2
	mov.l r2, @r1	

	/*
	 *  DDR-MRS write
	 */
	mov.l _ddr_sdmr3_addr, r1
	mov.l _ddr_sdmr3_val, r2
	mov.w r2, @r1	

	/*
	 *  RMODE=0:Auto Reflesh
	 *  DRI=4E1cyc:4E1x6.25ns=7.8uS, 64mS/8192REFA=7.81uS
	 *  DRE=1:refresh enable,DLLEN=1:DLL enable
	 *  DCE=1:DDR controller enable
	 */
	mov.l _ddrif_min_h_addr, r1
	mov.l _ddrif_min_h_val, r2
	mov.l r2, @r1
	mov.l _ddrif_min_l_addr, r1
	mov.l _ddrif_min_l_val, r2
	mov.l r2, @r1

	/*
	 *  waiting for MCLK200cycle(=1.25uS)
	 */
	mov.l _loop_from, r1
	mov.l _loop_dec,  r2
_loop:
	add    r2, r1		
	cmp/pl r1
	bt     _loop

	/*
	 *  NORMAL   command issue
	 */
	mov.l _ddrif_scr_h_addr, r1
	xor   r2,r2
	mov.l r2, @r1
	mov.l _ddrif_scr_l_addr, r1
	mov.l _ddrif_scr_l_val_0, r2
	mov.l r2, @r1
	
#endif

	mov.l _ccr_addr, r1
	mov.l _ccr_disable, r2
	mov.l r2, @r1
	mov.l _ccr_mode, r2
	mov.l r2, @r1
	
    rts
     nop


    .align 4
#ifdef ROM_BOOT
_lbsc_mmselr_addr:
	.long LBSC_MMSELR
_lbsc_mmselr_val:
	.long 0xa5a50000

_lbsc_cs0bcr_addr:
	.long LBSC_CS0BCR
_lbsc_cs0bcr_val:
	.long 0x00000000
_lbsc_cs0wcr_addr:
	.long LBSC_CS0WCR
_lbsc_cs0wcr_val:
	.long 0x00020005

_ddr_base_addr:
	.long DDR_BASE_ADDR

_ddr_dmwr_l_addr:
	.long DDR_DMWR_L
_ddr_dmwr_l_val:
	.long 0xa5000000

_ddrif_min_h_addr:
	.long DDRIF_MIM_H
_ddrif_min_h_val:
	.long 0x00004000
_ddrif_min_l_addr:
	.long DDRIF_MIM_L
_ddrif_min_l_val:
	.long 0x04e10209
_ddrif_sdr_h_addr:
	.long DDRIF_SDR_H
_ddrif_sdr_h_val:
	.long 0x00000000
_ddrif_sdr_l_addr:
	.long DDRIF_SDR_L
_ddrif_sdr_l_val:
	.long 0x00000300
_ddrif_str_h_addr:
	.long DDRIF_STR_H
_ddrif_str_h_val:
	.long 0x00000000
_ddrif_str_l_addr:
	.long DDRIF_STR_L
_ddrif_str_l_val:
	.long 0x00003180

_ddrif_scr_h_addr:
	.long DDRIF_SCR_H
_ddrif_scr_l_addr:
	.long DDRIF_SCR_L

_ddrif_scr_l_val_0:
	.long 0x00000000
_ddrif_scr_l_val_2:
	.long 0x00000002
_ddrif_scr_l_val_3:
	.long 0x00000003
_ddrif_scr_l_val_4:
	.long 0x00000004

_ddr_sdmr1_addr:
	.long DDR_SDMR1
_ddr_sdmr1_val:
	.long  0x0000
_ddr_sdmr2_addr:
	.long DDR_SDMR2
_ddr_sdmr2_val:
	.long  0x0000
_ddr_sdmr3_addr:
	.long DDR_SDMR3
_ddr_sdmr3_val:
	.long  0x0000

_loop_from:
	.long 200
_loop_dec:
	.long   -1	
	
#endif
_ccr_addr:
	.long CCR
_ccr_disable:
	.long CCR_DISABLE
_ccr_mode:
	.long CCR_MODE

    /*
     *  ĥӥν
     *  ƤӽФξ
     *    BL == 1, RB == 1߶ػߡ쥸Х1
     *    14ѥ᡼R4R7
     *    5ѥ᡼R2  ƥॹåΰֲѤ
     *    ǽɡR1
     *    p_runtskr8_bank1
     *    ƤӽФꤹ뤿Υӥåȥޥåסr9_bank1
     *      0x01: r7_bank1 == 0 && rundom != TACP_KERNEL
     *      0x02: r7_bank1 == 0
     *    åpr, r8_bank1r9_bank1
     *    ø⡼ɼ¹ or 󥿥ƥ
     *      priv_mode == 1 or r7_bank_1 > 0
     *    ƥॹå or 󥿥ƥѥå
     *    ǽɤβ¥åϼ¹ԺѤ
     */
    .section .text_kernel
    .global _extsvc_entry
    .extern	__kernel_extsvc_table
    .extern	__kernel_tmax_fncd
    .extern __kernel_call_texrtn_stask

#define SIZEOF_SVCINIB 8
#define SVCINIB_svcrtn 0
#define SVCINIB_stksz  4

    .align 4
/*
 *  顼ˤ㳰ޥ֤ǥפƤ
 */
extsvc_error_RSFN:
	mov.l	_e_rsfn_svc, r0     /* 顼ɤ֤ */
    ldc     r0, r0_bank         /* Х0R0˥顼ɤ */
    bra     svc_entry_r
    nop

extsvc_error_NOMEM:
	mov.l   _e_nomem_svc, r0    /* 顼ɤ֤ */
    ldc     r0, r0_bank         /* Х0R0˥顼ɤ */
    bra     svc_entry_r
    nop
extsvc_error_SYS:
	mov.l   _e_sys_svc, r0      /* 顼ɤ֤ */
    ldc     r0, r0_bank         /* Х0R0˥顼ɤ */
    bra     svc_entry_r
    nop

_extsvc_entry:
extsvc_entry_1:
    /*
     *  ǽɤΥå
     */
    mov.l   _tmax_fncd_extsvc, r0
    mov.l   @r0, r0
    stc     r1_bank, r1             /* ǽɤХ0R1 */
    cmp/gt  r0, r1                  /* ǽɤξ¥å(tmax_fncd < r1) */
    bt      extsvc_error_RSFN       /* ¤򥪡ФƤʤХ顼 */

    /*
     *  ĥӥΥơ֥
     *  R3 = &svcinib
     */
    mov     #3, r3
    add     #-1, r1                     /* ǽ -= 1 */
    mov     r1, r0                      
    shad    r3, r0                      /* r0 = (ǽ - 1) << 3 (=*8) */
    mov.l   _svcinib_table_extsvc, r3
    add     r0, r3                      /* R3 += R0(ơ֥ƬϤоǤؤΥեåȤä) */

    /*
     *  ĥӥΤΥɥ쥹NULLǤʤ
     */
    mov.l   @(SVCINIB_svcrtn,r3), r0    /* R0 = svcinib->svcrtn */
    cmp/eq  #0, r0                      /* R0 == NULL? */
    bt      extsvc_error_RSFN           /* NULLʤХ顼 */
    ldc     r0, r1_bank                 /* r1_bank0 = svcinib->svcrtn */

    /*
     *  ƤӽФ󥿥ƥȤ
     */
	mov     #TDOM_KERNEL, r1    /* ƤӽФTDOM_KERNEL */
    mov     #0x02, r0
    tst     r0, r9          /* r7_bank1 != 0 */
	bt      extsvc_entry_3	/* 󥿥ƥȤʤХå */

extsvc_entry_2:
    /*
     *  åλ̤å
     */
    mov.l   @(TCB_p_tinib,r8), r2
    mov.l   @(TINIB_sstk_bottom,r2), r1 /* R1 = åνλ */
    mov     r15, r0                     /* R0 = ssp */
    cmp/hi  r1, r0                      /* r1 < r0 ʤ */
    bt      extsvc_error_NOMEM          /* 顼 */
    sub     r0, r1                      /* R1 = sstk_bottom - ssp */
    mov.l   @(SVCINIB_stksz,r3), r0     /* R0 = svcinib->stksz */
    addv    r0, r1                      /* r1 += svcinib->stksz: Хե */
    bt      extsvc_error_NOMEM          /* 顼 */
    mov.l   @(TINIB_sstksz,r2), r3      /* R3 = å */
    cmp/hs  r1, r3                      /* r1 <= å */
    bf      extsvc_error_NOMEM          /* ǤʤХ顼 */

    /*
     *  svclevel򥤥󥯥
     */
    mov.b   @(TCB_svclevel,r8), r0  /* svclevelɤ߹ */
    mov     #255, r3
    cmp/hs  r3, r0                  /* svclevelξ¥å(r3 <= r0:unsigned) */
	bt      extsvc_error_SYS        /* ͥȤξ¤ä票顼 */
	add     #1, r0                  /* svclevel += 1 */
    mov.b   r0, @(TCB_svclevel,r8)  /* svclevel򹹿 */


    /*
     *  ¹ԥɥᥤ򥫡ͥɥᥤ
     */
	mov     #TDOM_KERNEL, r1    /* ƤӽФTDOM_KERNEL */
    mov     #0x01, r0
    tst     r0, r9          /* rundom != TACP_KERNEL  */
	bt      extsvc_entry_3	/* ͥɥᥤʤХå */
    mov.l   _rundom_svc, r3     /* R3 = &rundom */
    mov     #0, r0
	mov.l	r0, @r3             /* rundom = TACP_KERNEL */

    mov.l   @(TINIB_p_dominib,r2), r0   /* R0 = p_dominib */
    mov.l   @(DOMINIB_asid, r0), r1     /* R1 = p_dominib->domctxb.asid */

extsvc_entry_3:
    /*
     *  domid򥹥åѤ
     */
	mov.l   r1, @-r15           /* ƤӽФdomid򥹥åѤ */

    /*
     *  BLӥåȤ0ˤ쥸Х󥯤0ڤؤ
     *  㳰ޥ֤
     */
    mov.l  _unmak_rb_bl_svc,r2
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr

	mov.l   r2, @-r15           /* 5򥹥åѤ */

    /*
     *  ĥӥΤƤ
     */
	jsr     @r1                     /* ӥ롼Ƥ */
    nop
	mov.l   @r15+, r2               /* 5򥹥å */
	mov.l   @r15+, r2               /* ƤӽФdomid򥹥å */

extsvc_entry_r:
    /*
     *  ֥롼󥳡Ǥˤ뤿ᡤ
     *  åSR񤭴ʤɤνɬפʤ
     */
    /*
     *  BLӥåȤ1ˤ쥸Х󥯤1ڤؤ
     *  ֤ͤr0_bank0˳Ǽ
     *  㳰ޥ֤
     */
    mov.l  _mask_rb_bl_svc,r2
    stc    sr,r3               
    or     r3,r2            
    ldc    r2,sr
    /*
     *  λǤγͥ٥ޥr3_bank1¸
     *  - chg_ipmloc_cpuIMASK򹹿ؤб
     */
    mov.l  _mask_ipm_svc,r2
    stc    sr,r3               
    and    r2,r3            

    /*
     *  ƤӽФ󥿥ƥȤ
     */
    mov     #0x02, r0
    tst     r0, r9      /* excnest_count != 0 */
	bt      extsvc_prv_r   /* 󥿥ƥȤʤХ꥿ */

    /*
     *  svclevelǥ
     */
    mov.b   @(TCB_svclevel,r8), r0  /* svclevelɤ߹ */
    dt      r0                      /* svclevel -= 1 && svclevel0 */
    mov.b   r0, @(TCB_svclevel,r8)  /* svclevel򹹿 */
    bf      extsvc_prv_r               /* 0ǤʤХ꥿ */
    
    /*
     *  ¹ԥɥᥤ°ɥᥤ᤹
     */
   	mov.l	@(TCB_p_tinib,r8), r0       /* ֥åɤ߽Ф */
	mov.l	@(TINIB_p_dominib,r0), r0   /* ɥᥤ֥åɤ߽Ф */
	mov.l	@(DOMINIB_domptn,r0), r0    /* °ɥᥤμ */
    mov.l   _rundom_svc, r1             /* R1 = &rundom */
    mov.l   r0, @r1                     /* rundom = °ɥᥤ */
    /*
     *  ӥ¹˳ĥӥ뤳ȤϤʤᡢ
     *  ꥿褬󥿥ƥȤǤʤʤС꥿
     *  㳰α֤ǤϤʤ
     */

    /*
     *  Ԥػ߾֤
     */
    mov     #TCB_waifbd, r0
    mov.b   @(r0,r8), r1
    mov     #TCB_waifbd_mask, r2
    not     r2, r2
    and     r2, r1
    mov.b   r1, @(r0,r8)

    /*
	 *  㳰¹Ծ郎äƤ뤫å
	 */
	mov.l	@(TCB_texptn,r8), r0    /* α㳰װɽФ */
    cmp/eq  #0, r0                  /* α㳰װ0 */
	bt      extsvc_r                /* 0ʤ꥿ */
    mov     #TCB_enatex, r0
	mov.b	@(r0,r8), r0            /* 㳰ľ֤ɽФ */
    and     #TCB_enatex_mask, r0
    cmp/eq  #0, r0                  /* 㳰ػ߾֤ */
	bt      extsvc_r                /* ػߤʤ꥿ */

	/*
     *  ߥޥ֤ 
     */
    mov.l   _ipmflg_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bt      extsvc_r

	/*
     *  ӥ뤫Υ꥿Υƥ֤CPUå֤
     */
    mov.l   _lock_flag_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bf      extsvc_r             /* CPUå֤ǤʤХ꥿ */
    nop

    /*
     *  褬桼ɥᥤ󤫥å
     */
    mov     #0x01, r0
    tst     r0, r9          /* ƤӽФΥɥᥤ == TACP_KERNEL */
	bf      extsvc_usr_r_texrtn
    nop
extsvc_prv_r_texrtn:
    /*
     *  CPUå
     */
    mov.l   _lock_flag_svc, r0
    mov     #1, r1
    mov.l   r1, @r0

    mov.l   _saved_iipm_svc, r0
    mov     #IIPM_ENAALL, r1
    mov.l   r1, @r0

    mov.l   r3, @-r15
    stc     r0_bank, r0
    mov.l   r0, @-r15

    /*
     *  srCPUåξ֤
     *  MD = 0, RB = 0, BL = 0, IMASK = IIPM_LOCK 
     */
    mov.l  _mask_md_ipm_svc, r2
    ldc    r2,sr

    mov.l   _call_texrtn_stask_extsvc, r0
    jsr     @r0  /* ƥॿѤΥ㳰 */
    nop

    /*
     *  BLӥåȤ1ˤ쥸Х󥯤1ڤؤ
     *  㳰ޥ֤
     */
    mov.l  _mask_rb_bl_svc,r2
    stc    sr,r3               
    or     r3,r2            
    ldc    r2,sr

    mov.l   @r15+, r0
    mov.l   @r15+, r3
    ldc     r0, r0_bank

    /*
     *  ꥿CPUåȤʤ褦
     */
    mov.l   _lock_flag_svc, r0
    mov     #0, r1
    mov.l   r1, @r0

extsvc_prv_r:
    bra     svc_prv_r       /* TACP_KERNELξ */
    nop
extsvc_usr_r_texrtn:
    mov.l  r3, @-r15

    /*
     *  쥸Х󥯤0ڤؤ
     */
    mov.l  _unmask_rb_svc,r2
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr
   
    /*
     *  r0 = p_runtsk
     */
    mov.l   r0, @-r15
    mov     r8, r0
	bsr     _prepare_texrtn_utask    /* 桼ѤΥ㳰 */
    nop
    mov.l   @r15+, r0
    /*
     *  쥸Х󥯤1ڤؤ
     */
    mov.l  _mask_rb_bl_svc,r2
    stc    sr,r3               
    or     r3,r2            
    ldc    r2,sr
    mov.l  @r15+, r3
    bra     svc_usr_r       /* TACP_KERNELǤʤ */
    nop

extsvc_r:
    /*
     *  褬桼ɥᥤ󤫥å
     */
    mov     #0x01, r0
    tst     r0, r9          /* ƤӽФΥɥᥤ == TACP_KERNEL */
    bt      svc_prv_r       /* TACP_KERNELξ */
    nop
    bra     svc_usr_r       /* TACP_KERNELǤʤ */
    nop

    .align 4
_tmax_fncd_extsvc:
    .long   _tmax_fncd
_svcinib_table_extsvc:
    .long   _svcinib_table
_e_nomem_svc:
    .long   E_NOMEM
_e_sys_svc:
    .long   E_SYS
_call_texrtn_stask_extsvc:
    .long   _call_texrtn_stask

    /*
     *  ӥν
     *  ƤӽФξ
     *    BL == 1, RB == 1߶ػߡ쥸Х1
     *    14ѥ᡼R4R7
     *    5ѥ᡼R2  ƥॹåΰֲѤ
     *    ǽɡR1
     *  쥸λ
     *    p_runtskR8
     *    ƤӽФꤹ뤿ΥӥåȥޥåסR9
     *      0x01: r7_bank1 == 0 && rundom != TACP_KERNEL
     *      0x02: r7_bank1 == 0
     *    åpr, r8r9
     */
    .global __kernel_svc_entry
    .section .text_kernel
    .align 2
__kernel_svc_entry:
    sts.l   pr, @-r15   /* PR */
    mov.l   r8, @-r15   /* r8 */
    mov.l   r9, @-r15   /* r9 */

svc_entry_0:
    mov.l   __kernel_p_runtsk_svc, r8   /* ¹Υ */
    mov.l   @r8, r8   /* ¹Υ */
    /* 
     *  R9: ƤӽФꤹ뤿Υӥåȥޥå
     *    0x01: excnest_count == 0 && rundom != TACP_KERNEL
     *    0x02: excnest_count == 0
     */
    mov     #0, r9 /* 0 */

    /*
	 *  ƥȤθƤӽФå
	 */
    tst     r7, r7      /* ¿ųߤǤʤ */
	bf      svc_entry_1 /* ¿ųߤʤХå */
    mov     #0x02, r0
    or      r0, r9      /* r7_bank1 == 0ΥӥåȤ򥻥å */

    /*
     *  桼ɥᥤ󤫤θƤӽФå
     *  ĥӥ¹ǤС
     *  ͥɥᥤ󤫤θƤӽФȤʤΤǡ
     *  svclevelΥåɬפʤ
     */
    mov.l   _rundom_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0          /* rundom == 0(TACP_KERNEL) */
    bt      svc_entry_1     /* 0ʤХå */
    mov     #0x01, r0
    or      r0, r9          /* rundom != TACP_KERNELΥӥåȤ򥻥å */

    /*
     *  ξ֤ø⡼ɼ¹˰ܹԤ
     *  褬ƥȤʤС¹ǤϤ
     *  ʤΤǡp_runtskNULLɤΥåɬפʤϤ
     */
    mov     #1, r1
    mov     #TCB_priv_mode, r0
    mov.b	r1,	@(r0,r8)     /* ø⡼ɼ¹ */

svc_entry_1:
    /*
     *  ǽɤΥå
     */
    mov.l   _tmin_fncd_svc, r0
    stc     r1_bank, r1     /* ǽɤХ0R1 */
	cmp/ge  r0, r1       	/* ǽɤβ¤Υå(TMIN_FNCD <= r1) */
	bf      svc_entry_7     /* ¤ⲼʤХ顼 */
    mov     #0, r0   
	cmp/gt  r0, r1 			/* ǽɤå(0 < r1) */
    bf      svc_entry_2     /* ӥξ */
    nop
	bra     _extsvc_entry   /* ĥӥξ */
    nop

svc_entry_2:
    /*
     *  BLӥåȤ0ˤ쥸Х󥯤0ڤؤ
     *  㳰ޥ֤
     */
    mov.l  _unmak_rb_bl_svc,r2
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr

	mov.l   r2, @-r15       /* 5򥹥åѤ */

    /*
     *  ӥΥơ֥
     *  ӥΤƤ
     */
	neg     r1, r1          /* ȿž */
    shal    r1
    shal    r1              /* 2bitե(4:ɥ쥹Ĺ4byte) */
    mov.l   _svc_table_svc, r0
	mov.l   @(r0,r1), r1    /* ơ֥ */
	jsr     @r1             /* ӥ롼Ƥ */
    nop
	mov.l   @r15+, r2       /* 5򥹥å */
    /*
     *  BLӥåȤ1ˤ쥸Х󥯤1ڤؤ
     *  ֤ͤr0_bank0˳Ǽ
     *  㳰ޥ֤
     */
    mov.l  _mask_rb_bl_svc,r2
    stc    sr,r3               
    or     r3,r2            
    ldc    r2,sr

svc_entry_r:
    /*
     *  ˤ㳰ޥ֤ǥפƤ
     */
    /*
     *  λǤγͥ٥ޥr3_bank1¸
     *  - chg_ipmloc_cpuIMASK򹹿ؤб
     */
    mov.l  _mask_ipm_svc,r2
    stc    sr,r3               
    and    r2,r3            

    /*
     *  褬桼ɥᥤ󤫥å
     *  ĥӥ¹ǤС
     *  ϥͥɥᥤʤΤǡ
     *  svclevelΥåɬפʤ
     */
    mov     #0x01, r0
    tst     r0, r9          /* rundom == TACP_KERNEL */
    bt      svc_prv_r       /* TACP_KERNELʤХå */

    /*
	 *  褬ƥȤå
	 */
    mov     #0x02, r0
    tst     r0, r9          /* excnest_count != 0 */
    bt      svc_prv_r       /* 0ǤʤХå */

	/*
	 *  Ԥػߤ
	 */
    mov     #TCB_waifbd, r0
    mov.b   @(r0,r8), r1
    mov     #TCB_waifbd_mask, r2
    not     r2, r2
    and     r2, r1
    mov.b   r1, @(r0,r8)
	
    /*
	 *  㳰¹Ծ郎äƤ뤫å
	 */
	mov.l	@(TCB_texptn,r8), r0    /* α㳰װɽФ */
    cmp/eq  #0, r0                  /* α㳰װ0 */
	bt      svc_usr_r               /* 0ʤ꥿ */
    mov     #TCB_enatex, r0
	mov.b	@(r0,r8), r0            /* 㳰ľ֤ɽФ */
    and     #TCB_enatex_mask, r0
    cmp/eq  #0, r0                  /* 㳰ػ߾֤ */
	bt      svc_usr_r               /* ػߤʤ꥿ */

	/*
     *  ߥޥ֤ 
     */
    mov.l   _ipmflg_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bt      svc_usr_r               /* ipmflg == falseʤ꥿ */

	/*
     *  ӥ뤫Υ꥿Υƥ֤CPUå֤
     */
    mov.l   _lock_flag_svc, r0
    mov.l   @r0, r0
    cmp/eq  #0, r0
    bf      svc_usr_r             /* CPUå֤ǤʤХ꥿ */
    nop

    /*
     *  㳰ƤӽФ郎·äƤС
     *  桼Υ㳰
     *  r0 = p_runtsk
     */
    mov.l  r3, @-r15
    /*
     *  쥸Х󥯤0ڤؤ
     */
    mov.l  _unmask_rb_svc,r2
    stc    sr,r3               
    and    r3,r2            
    ldc    r2,sr
   
    mov.l   r0, @-r15
    mov     r8, r0
    bsr      _prepare_texrtn_utask
    nop
    mov.l   @r15+, r0
    /*
     *  쥸Х󥯤1ڤؤ
     */
    mov.l  _mask_rb_bl_svc,r2
    stc    sr,r3               
    or     r3,r2            
    ldc    r2,sr
 
    mov.l  @r15+, r3

svc_usr_r:
    mov     #0, r1
    mov     #TCB_priv_mode, r0
	mov.b	r1,	@(r0,r8)     /* ø⡼ɼ¹Ԥȴ */
    
svc_prv_r:
    mov.l   @r15+, r9   /* r9 */
    mov.l   @r15+, r8   /* r8 */
    lds.l   @r15+, pr   /* pr */
    rts
    nop

/*
 *  顼ˤ㳰ޥ֤ǥפƤ
 */
svc_entry_7:
	mov.l   _e_rsfn_svc, r0 /* 顼ɤ֤ͤ */ 
    ldc     r0, r0_bank         /* Х0R0˥顼ɤ */
	bra     svc_entry_r     /* ӥνи */
    nop

    .align 4
_saved_iipm_svc:
    .long _saved_iipm
__kernel_p_runtsk_svc:
    .long __kernel_p_runtsk
_rundom_svc:
    .long _rundom
_svc_table_svc:
    .long _svc_table
_unmak_rb_bl_svc:
    .long  0x4fffffff
_unmask_rb_svc:
    .long  0x5fffffff
_mask_rb_bl_svc:
    .long  0x30000000
_tmin_fncd_svc:
    .long TMIN_FNCD
_e_rsfn_svc:
    .long E_RSFN
_lock_flag_svc:
    .long _lock_flag
_ipmflg_svc:
    .long _ipmflg
_mask_ipm_svc:
    .long 0x000000f0
_mask_md_ipm_svc:
    .long (0x40000000 + INT_IPM(TIPM_LOCK))

    /*
     *  桼Υ㳰롼
     *  ƽФ
     *  - ߶ػ߾֡BL == 1
     *  - 쥸Х0RB == 0
     *  - ø⡼ɼ¹MD == 1
     *  - sstk
     *  - R0 = p_runtsk
     */
    .global _prepare_texrtn_utask
    .section .text_kernel
    .align 2
/*
 *  㳰¹Գϻå㳰ϥɥƤӽФ
 */
error_nomem_texrtn:
    /*
     *  ߥ졼Ȥ줿CPU㳰Ƥ
     *  㳰Υ꥿prepare_texrtn_utaskθƤӽФ褦˽
     */
    sts     pr, r0
    ldc     r0, spc
    stc     sr, r0     
    ldc     r0, ssr     
    /*
     *  㳰ֹ򥻥å
     */
    mov.l   _emulate_exception_no_texrtn, r1
    mov.l   _expevt_texrtn, r0
    mov.l   r1, @r0
    /*
     *  srMD = 1, RB = 1, BL = 1, IMASK = IIPM_LOCK
     */
    mov.l   _mask_md_rb_bl_ipm_texrtn, r0
    ldc     r0, sr
    /*
     *  㳰
     */
    bra     _emulate_exc_entry
    nop
    /*
     *  ˤϤʤϤ
     */
error_nomem_texrtn_loop:
    bra     error_nomem_texrtn_loop
    nop

    .align 4
_emulate_exception_no_texrtn:
    .long EXCNO_EMU_TEXRTN
_expevt_texrtn:
    .long EXPEVT
_mask_md_rb_bl_ipm_texrtn:
    .long (0x70000000 + INT_IPM(TIPM_LOCK))


    .align 2
_prepare_texrtn_utask:
    /*
     *  桼åλ̤å
     *  uspθ
     *  ø⡼ɻ˻Ѥ륵
     *    㳰ΤǻѤʬˤĤƤϡ
     *    桼⡼ɤǼ¹Ԥ뤿ᡤ
     *    ¹Ի˥åХե򸡽ФǤ
     */
    mov.l   @(TCB_p_tinib, r0), r1          /* r1 = p_runtsk->tinib */
    mov.l   @(TINIB_ustk_bottom, r1), r3    /* r3 = 桼åΥɥ쥹 */
    mov.l   @(TCB_usp, r0), r2              /* r2 = usp */
    cmp/hi  r3, r2                          /* r3 < r2 ʤ */
    bt      error_nomem_texrtn              /* 顼 */
    sub     r2, r3                          /* r3 = ustk_bottom - usp:  */
    mov     #(3*4), r4
    addv    r3, r4                          /* r4 += r3: Хե */
    bt      error_nomem_texrtn              /* 顼 */
    mov.l   @(TINIB_ustksz, r1), r3         /* r3 = 桼åΥ */
    cmp/hs  r4, r3                          /* r4 <= å */
    bf      error_nomem_texrtn              /* 顼 */
    nop

/*#define _DEBUG_MODE_EMULATE_CPUEXC_*/
#ifdef _DEBUG_MODE_EMULATE_CPUEXC_
    bra     error_nomem_texrtn
    nop
#endif /* _DEBUG_MODE_EMULATE_CPUEXC_ */

    /* 
     *  桼åؤ
     *                                  <- old usp
     *   ϡPR
     *   ǥѥåα֡dspflg
     *   ǥѥåػ߾֡disdsp   <- new usp
     */
    sts.l   pr, @-r2                    /* PR */
    mov.l   _dspflg_texrtn, r3          /* r3 = &dspflg */
    mov.l   @r3, r3                     /* r3 = dspflg */
    mov.l   r3, @-r2                    /* dspflg */
    mov.l   _disdsp_texrtn, r3          /* r3 = &disdsp */
    mov.l   @r3, r3                     /* r3 = disdsp */
    mov.l   r3, @-r2                    /* disdsp */
    mov.l   r2, @(TCB_usp, r0)          /* uspι */

_prepare_texrtn_utask_r:
    /*
     *  ø⡼ɤƥ㳰롼إ
     */
    /*
     *  㳰롼󤫤Ϥcall_ret_tex˻
     */
    mov.l   _call_ret_tex_texrtn, r2
    lds     r2, pr

    /*
     *  㳰롼إ׸Υƥ֤CPUå֤Ȥ
     */
    mov.l   _lock_flag_texrtn, r2
    mov     #0, r4
    mov.l   r4, @r2

    /*
     *  SSR
     *  桼⡼ɡ쥸Х0㳰ޥcpuå
     *  MD = 0RB = 0BL = 0IMASK = saved_iipm
     */
    ldc     r3, ssr

    /*
     *  㳰롼ΰ
     */
    /* 1R4 = p_runtsk->texptn */
    /* 2R5 = p_runtsk->p_tinib->exinf */
    mov.l   @(TCB_texptn, r0), r4       /* 㳰ѥ */
    ldc     r4, r4_bank                 /* bank0R4 */
    mov.l   @(TINIB_exinf, r1), r5      /* ĥ */
    ldc     r5, r5_bank                 /* bank0R5 */

    /* 
     *  㳰롼Υɥ쥹
     *  SPC = 㳰Ƭɥ쥹
     */
    mov.l   @(TINIB_texrtn, r1), r2     
    ldc     r2, spc     

    /*
     *  桼åؤڤؤ
     */
    mov.l   r15, @(TCB_ssp, r0)         /* ssp¸ */
    mov.l   @(TCB_usp, r0), r15         /* uspΥå */

    mov     #0, r2
    mov     #TCB_priv_mode, r1
	mov.b	r2,	@(r0,r1)     /* ø⡼ɼ¹Ԥȴ */
	mov.l	r2,	@(TCB_texptn, r0)       /* p_runtsk->texptn = 0 */
    mov     #TCB_enatex, r3
	mov.b	@(r0, r3), r1       /* p_runtsk->enatex = false */
    mov     #TCB_enatex_mask, r2
    not     r2, r2
    and     r2, r1
	mov.b	r1,	@(r0, r3)        /* p_runtsk->enatex = false */
   
    rte                 /* 㳰Υ꥿ˤäƥ㳰 */
    nop

    .align 4
_call_ret_tex_texrtn:
    .long _call_ret_tex
_dspflg_texrtn:
    .long _dspflg
_disdsp_texrtn:
    .long _disdsp
_lock_flag_texrtn:
    .long _lock_flag
_saved_iipm_texrtn:
    .long _saved_iipm


#define ACVCT_ACPTN1 0
#define ACVCT_ACPTN2 4
#define USTK_pr      8
#define USTK_dspflg  4
#define USTK_disdsp  0

    /*
     *  㳰νи
     *  ƤӽФξ
     *    BL == 1, RB == 1߶ػߡ쥸Х1
     *    ƥॹå
     */
    .global _ret_tex
    .section .text_kernel
    .align 2

_error_context_ret_tex:
    rts

_ret_tex:
    /*
     *  ƽФø⡼ɤʤХ顼
     *  SSRå
     */
    stc     ssr, r0             /* r0 = 㳰ȯľSR */
    shll    r0                  /* SRMSB̵ */
    shll    r0                  /* SRMSBμΥӥåȤMD -> ø⡼ɡMD==1ˤʤT=1 */
    bt      _error_context_ret_tex  /* ȯø⡼ɤʤ饨顼 */
    nop
    mov.l   _p_runtsk_ret_tex, r0
    mov.l   @r0, r0
    tst     r0, r0
    bt      _error_context_ret_tex  /* 顼 */

ret_tex_0:
    /*
     *  桼åλ̤å
     *  uspθ
     *  ø⡼ɻ˻Ѥ륵
     *    㳰ǥ桼å줿ؤб
     */
    mov.l   @(TCB_p_tinib, r0), r1          /* r1 = p_runtsk->tinib */
    mov.l   @(TINIB_ustk_bottom, r1), r4    /* r4 = 桼åΥɥ쥹 */
    mov.l   @(TINIB_ustksz, r1), r3         /* r3 = 桼åΥ */
    cmp/hi  r4, r3                          /* r4 < r3 ʤ */
    bt      error_nomem_ret_tex             /* 顼 */
    mov     r4, r5
    sub     r3, r4                          /* r4 = ustk_bottom - ustksz */
    mov.l   @(TCB_usp, r0), r2              /* r2 = usp */
    cmp/hi  r2, r4                          /* r4 > r2 ʤ */
    bt      error_nomem_ret_tex             /* 顼 */
    mov     #(3*4), r4
    mov     r2, r3
    addv    r4, r3                          /* r3 = usp + size: Хեȯ */
    bt      error_nomem_ret_tex             /* 顼 */
    cmp/hi  r5, r3                          /* r3 > r5 ʤ */
    bt      error_nomem_ret_tex             /* 顼 */
    nop

/*#define _DEBUG_MODE_EMULATE_CPUEXC_REX_*/
#ifdef _DEBUG_MODE_EMULATE_CPUEXC_REX_
    bra     error_nomem_ret_tex
    nop
#endif /* _DEBUG_MODE_EMULATE_CPUEXC_REX_ */
    /*
     *  λǡr2 = usp
     */

    ldc     r0, r0_bank
    ldc     r2, r2_bank

    /*
     *  r3 = rundom
     */
    mov.l   _rundom_ret_tex, r3
    mov.l   @r3, r3

    /*
     *  CPUå
     *  ipm桼å
     *    㳰顤CPUåͥ٥ޥ
     *    ѹޤޥ꥿󤷤ؤк
     */
    mov.l    _kernel_sysstat_acvct_ret_tex, r4
    mov.l    @(ACVCT_ACPTN2,r4), r1
    tst      r1, r3                              /* sysstat_acvct.acptn2 & rundom == 0? */
    bt       ret_tex_1
    /*
     *  ꥿Υƥ֤CPUå֤Ȥ
     */
    mov.l   _lock_flag_ret_tex, r5
    mov     #0, r1
    mov.l   r1, @r5

ret_tex_1:
    /*
     *  disdsp桼å
     *    㳰顤ǥѥåػߤޤ
     *    ꥿󤷤ؤк
     */
    mov.l    @(ACVCT_ACPTN1,r4), r4
    tst      r4, r3                              /* sysstat_acvct.acptn1 & rundom == 0? */
    bt       ret_tex_2
    /*
     *  disdsp桼å
     */
    mov.l   _disdsp_ret_tex, r1
    mov.l   @(USTK_disdsp, r2), r3
    mov.l   r3, @r1
    /*
     *  dspflg򹹿
     *  ͥ٥ޥ֤ΤϤʤΤǡ
     *  disdspΤߤȽǤФ褤
     *  Τᡤdisdsp򥿥㳰᤹ʤС
     *  dspflg⥿㳰
     */
    mov.l   _dspflg_ret_tex, r1
    mov.l   @(USTK_dspflg, r2), r3
    mov.l   r3, @r1

ret_tex_2:
    /*
     *  p_runtsk->enatex = false
     */
    mov     #TCB_enatex, r4
	mov.b	@(r0, r4), r1    /* 㳰ľ֤ɽФ */
    mov     #TCB_enatex_mask, r5
    not     r5, r5
    and     r5, r1
    mov.b   r1, @(r0, r4)

    /*
     *  dspflgtrue
     */
    mov.l   _dspflg_ret_tex, r3
    mov.l   @r3, r3
    tst     r3, r3          /* dspflg == false? */
    bt      ret_tex_3 /* falseʤǥѥåʤ */
    /*
     *  p_runtsk != p_schedtsk 
     */
	mov.l   _p_schedtsk_ret_tex, r3 /* r3 <- schedtsk */
	mov.l   @r3, r3
	cmp/eq  r0, r3   				/* runtsk  schedtsk  */
	bt	    ret_tex_3         /* Ʊʤǥѥåʤ */
    /*
     *  CPUå֤
     */
    mov.l   _lock_flag_ret_tex, r4
    mov     #0, r1
    mov.l   r1, @r4

    mov.l   _saved_iipm_ret_tex, r4
    mov     #IIPM_ENAALL, r1
    mov.l   r1, @r4

    /*
     *  SRΥå
     *  RB = 0IMASK = IIPM_LOCKBL = 0
     *  ͥγߤػ
     */
    mov.l   _mask_md_ipm_ret_tex, r3
    ldc     r3, sr

    /*
     *  dispatch
     */
    mov.l   _dispatch_ret_tex, r4
    jsr     @r4
    nop

    /*
     *  ꥿Υƥ֤CPUå֤Ȥ
     */
    mov.l   _lock_flag_ret_tex, r1
    mov     #0, r0
    mov.l   r0, @r1

ret_tex_3:
    /*
     *  SRΥå
     *  RB = 0BL = 1
     *  ߤػ
     */
    mov.l   _mask_md_bl_ret_tex, r3
    ldc     r3, sr

    /*
	 *  α㳰װ뤫å
	 */
    mov.l   _p_runtsk_ret_tex, r0
    mov.l   @r0, r0
	mov.l	@(TCB_texptn,r0), r1    /* α㳰װɽФ */
    tst     r1, r1                  /* α㳰װ0 */
    bt      ret_tex_r               /* 0ʤХ꥿ */
    nop
    mov.l   @(TCB_ssp, r0), r15     /* ssp򥻥å */
    bra     _prepare_texrtn_utask_r /* 0ǤʤtexrtnƼ¹ */
    nop

ret_tex_r:
    mov.l   @(TCB_usp, r0), r2      /* r2 = usp */
    add     #USTK_pr, r2
    ldc.l   @r2+, spc      /* prspc */
    mov.l   r2, @(TCB_usp, r0)  /* usp᤹ */

    /*
     *  p_runtsk->enatex = true
     */
    mov     #TCB_enatex, r3
	mov.b	@(r0, r3), r1    /* 㳰ľ֤ɽФ */
    mov     #TCB_enatex_mask, r2
    or      r2, r1
    mov.b   r1, @(r0, r3)

    mov     #TCB_priv_mode, r2
    mov     #1, r1
    mov.b   r1, @(r0, r2) /* p_runtsk->priv_mode = true */

    rts
    nop

/*
 *  㳰꥿å㳰ϥɥƤӽФ
 */
error_nomem_ret_tex:
    /*
     *  ߥ졼Ȥ줿CPU㳰Ƥ
     *  㳰Υ꥿ret_texθƤӽФ褦˽
     *  TODO: 㳰꥿󤷤ư
     */
    /*
     *  㳰ֹ򥻥å
     */
    mov.l   _emulate_exception_no_ret_tex, r1
    mov.l   _expevt_ret_tex, r0
    mov.l   r1, @r0
    /*
     *  srMD = 1, RB = 1, BL = 1, IMASK = IIPM_LOCK
     */
    mov.l   _mask_md_rb_bl_ipm_ret_tex, r0
    ldc     r0, sr
    /*
     *  㳰
     */
    bra     _emulate_exc_entry
    nop
    /*
     *  ˤϤʤϤ
     */
error_nomem_ret_tex_loop:
    bra     error_nomem_ret_tex_loop
    nop

    .align 4
_rundom_ret_tex:
	.long _rundom
_kernel_sysstat_acvct_ret_tex:
    .long __kernel_sysstat_acvct
_call_ret_tex_ret_tex:
    .long _call_ret_tex
_lock_flag_ret_tex:
    .long _lock_flag
_dspflg_ret_tex:
    .long _dspflg
_disdsp_ret_tex:
    .long _disdsp
_p_schedtsk_ret_tex:
    .long _p_schedtsk
_p_runtsk_ret_tex:
    .long _p_runtsk
_dispatch_ret_tex:
    .long _dispatch
_mask_md_ipm_ret_tex:
    .long (0x40000000 + INT_IPM(TIPM_LOCK))
_mask_md_bl_ret_tex:
    .long 0x50000000
_saved_iipm_ret_tex:
    .long _saved_iipm
_emulate_exception_no_ret_tex:
    .long EXCNO_EMU_RET_TEX
_expevt_ret_tex:
    .long EXPEVT
_mask_md_rb_bl_ipm_ret_tex:
    .long (0x70000000 + INT_IPM(TIPM_LOCK))

    .section .text_kernel
    .align 4
    .extern _general_exc_vec_1
    /*
     *  SGRؤΥɤǤʤᡤr15򥹥å¸ȤޤǤ̽Ȥ롥
     */
_emulate_exc_entry:
    stc     ssr, r0             /* r0 = 㳰ȯľSR */
    shll    r0                  /* SRMSB̵ */
    shll    r0                  /* SRMSBμΥӥåȤMD -> ø⡼ɡMD==1ˤʤT=1 */
    bt      _emulate_exc_entry_0  /* ȯø⡼ɤʤ饹å */
    mov.l   _p_runtsk_emu, r0
    mov.l   @r0, r0             /* r0 = p_runtsk */
    tst     r0, r0              /* p_runtsk == NULL ? */
    bt      _emulate_exc_entry_0    /* ¹ǤʤХå: TODO: 桼⡼ɤǥ¹ǤʤȤϵꤦΤ */
    mov.l   r15, @(TCB_usp, r0)     /* usp¸ */
    /* ǡusp¸Τϡ㳰䤹뤿 */
    mov.l   @(TCB_ssp, r0), r15   /* ssp򥻥å */
_emulate_exc_entry_0:
    mov     r15, r0
    mov.l   r0,@-r15
    /*
     *  㳰
     */
    mov.l   _general_exc_vec_1_emu, r0
    jsr     @r0
    nop

    .align 4
_general_exc_vec_1_emu:
    .long _general_exc_vec_1
_p_runtsk_emu:
    .long _p_runtsk


    /*
     *  ret_texext_tskext_kertrap̿ǸƤӽФ
     */
    .global _call_ret_tex
    .section .text_shared
    .align 4
_call_ret_tex:
    trapa   #NO_RET_TEX
    nop
    mov     #TFN_EXT_TSK, r1
    trapa   #NO_SVC
    nop
    mov     #TFN_EXT_KER, r1
    trapa   #NO_SVC
    nop


